#include "cmscp.h"
#include "cmscp_sparseInfo.h"
#include "cmscp_consTypeInfo.h"
#include "cmscp_socpInfo.h"
#include "timer.h"
#include "printFunction.h"
#include "socSolveShell.h"
#include "freeSparseInfo.h"
#include "freeConsTypeInfo.h"
#include "freeSocpInfo.h"
#include "freeTrajInfo.h"

int cmscp(cmscp_trajInfo** optTraj, cmscp_setup* setup) {

	// 
	int iphase, iIter, stopFlag;
	double time;
	timer timer;
	cmscp_trajInfo** refTraj;
	cmscp_sparseInfo* sparseInfo;
	cmscp_consTypeInfo* consTypeInfo;
	cmscp_socpInfo* socpInfo;
	
	///*  */
	cmscp_getIniRefTraj getIniRefTrajFunc = setup->functions->getIniRefTraj; // ȡο켣ĺ
	cmscp_stopCondition stopConditionFunc = setup->functions->stopCondition; // ֹͣĺ
	cmscp_updateMeshInfo updateMeshInfoFunc = setup->functions->updateMeshInfo; // Ϣĺ
	cmscp_updateTrustInfo updateTrustInfoFunc = setup->functions->updateTrustInfo; // Ϣĺ
	cmscp_updateRefTraj updateRefTrajFunc = setup->functions->updateRefTraj; // ²ο켣Ϣĺ

	/* 1. ȡο켣 */
	refTraj = (cmscp_trajInfo**)malloc(setup->numPhase * sizeof(cmscp_trajInfo*));
	getIniRefTrajFunc(refTraj, setup);

	/* 2. ȡϡϢ */
	getSparseInfo(&sparseInfo, refTraj, setup);// refTrajֵָ븳ֵǷռ䣩ͰʹrefTrajĵַˣʱԴģ

	/* 3. ȡԼϢ */
	getConsTypeInfo(&consTypeInfo, setup);

	for (iIter = 0; iIter < setup->scpInfo->maxIter; iIter++)
	{
		/* 4. ȡ׶Ĳ */
		tic(&timer);
		getSocpInfo(&socpInfo, refTraj, sparseInfo, consTypeInfo, setup);
		time = toc(&timer);

		/* 6. Ž */
		socSolveShell(iIter, optTraj, socpInfo, setup);
		
		/* 7. ֹͣ */
		stopFlag = stopConditionFunc(iIter, refTraj, optTraj, setup);

		/* 8.  */
		updateTrustInfoFunc(iIter, refTraj, optTraj, setup);

		/* 9.  */
		updateMeshInfoFunc(iIter, refTraj, optTraj, setup);

		/* 10. ²ο켣 */
		updateRefTrajFunc(refTraj, optTraj, setup);

		// ֹͣﵽֹͣ
		if (stopFlag > 0)
		{
			setup->scpInfo->cntIter = iIter;
			break;
		}
	}
	// ͷSparseInfo
	freeSparseInfo(&sparseInfo, setup);
	// ͷConsTypeInfo
	freeConsTypeInfo(&consTypeInfo, setup);
	// Ź켣
	for ( iphase = 0; iphase < setup->numPhase; iphase++)
	{
		optTraj[iphase] = refTraj[iphase];
	}
	free(refTraj);
	// ֹͣ־λ
	return stopFlag;
}

