#pragma once
#include <string.h>
#include <stdlib.h>

/* 궨 */
#define INF 1.0E30
#define malloc malloc
#define FREE free

/* Ͷ */
typedef struct cmscp_floatDemat { // ͳܾ
	int m; // 
	int n; // 
	double* v; // д洢ÿһԪ
}cmscp_floatDemat;

typedef struct intDemat { // ͳܾ
	int m; // 
	int n; // 
	int* v; // д洢ÿһԪ
}intDemat;

typedef struct cmscp_crsSpmat { // ѹ洢ʽ
	int m;// 
	int n;// 
	int* ptrRow;// ÿ׸Ԫλ
	int* idxCol;// Ԫ
	double* v;// д洢ÿһԪ
}cmscp_crsSpmat;

typedef struct cmscp_ccsSpmat {// ѹ洢ʽ
	int m;// 
	int n;// 
	int* ptrCol;// ÿ׸Ԫλ
	int* idxRow;// Ԫ
	double* v;// д洢ÿһԪ
}cmscp_ccsSpmat;

typedef struct cmscp_trajInfo { // 켣Ϣṹ
	double initialtime;
	double finaltime;
	cmscp_floatDemat* state;
	cmscp_floatDemat* control;
	double* parameter;
}cmscp_trajInfo;

typedef struct cmscp_stopInfo {
	int isStop;
	double absTol;
}cmscp_stopInfo;

typedef struct cmscp_trustInfo {
	int numState;
}cmscp_trustInfo;

/* ͹Ż㷨 */
typedef struct cmscp_solverInfo {
	char* name;
	int maxit;
	double abstol;
	double reltol;
	double feastol;
	int verbose;
}cmscp_solverInfo;

typedef struct cmscp_scp {
	int maxIter;
	int cntIter;
	double* obj;
	cmscp_solverInfo* solver;
}cmscp_scp;


/* Լ߽ṹ */
typedef struct cmscp_boundscale {
	double lower;
	double upper;
}cmscp_boundscale;
typedef struct cmscp_boundvec {
	double* lower;
	double* upper;
}cmscp_boundvec;

typedef struct cmscp_boundcone {
	cmscp_boundvec* nl;
	double* soc;
}cmscp_boundcone;

typedef struct cmscp_boundPhase {
	cmscp_boundscale* initialtime;
	cmscp_boundscale* finaltime;
	cmscp_boundvec* initialstate;
	cmscp_boundvec* state;
	cmscp_boundvec* finalstate;
	cmscp_boundvec* control;
	cmscp_boundvec* parameter;
	cmscp_boundcone* path;
	cmscp_boundcone* endpoint;
	cmscp_boundcone* linkage;
}cmscp_boundPhase;

typedef struct cmscp_bound {
	cmscp_boundPhase** phase;
	cmscp_boundcone* event;
}cmscp_bound;


/* άṹ */
typedef struct cmscp_dimension1 {
	int n;
	int* q;
}cmscp_dimension1;
typedef struct cmscp_dimension2 {
	int nl;
	cmscp_dimension1* soc;
}cmscp_dimension2;

typedef struct cmscp_dimensionPhase {
	int state;
	int control;
	int parameter;
	cmscp_dimension2* path;
	cmscp_dimension2* endpoint;
	cmscp_dimension2* linkage;
}cmscp_dimensionPhase;

typedef struct cmscp_dimension {
	cmscp_dimensionPhase** phase;
	cmscp_dimension2* event;
}cmscp_dimension;

/* ṹ */
typedef struct cmscp_trustWeihgt {
	double initialtime;
	double finaltime;
	double* state;
	double* control;
	double* parameter;
}cmscp_trustWeihgt;

typedef struct cmscp_trustPhase {
	cmscp_trustWeihgt* weight;
	double hardRadius;
	double softPenaWeight;
}cmscp_trustPhase;

typedef struct cmscp_trust {
	char* model;
	double merit;
	cmscp_trustPhase** phase;
}cmscp_trust;

/* ⺯ƽṹ */
typedef struct cmscp_contInput {
	void* auxdata;
	double* state;
	double* control;
	double* parameter;
}cmscp_contInput;

typedef struct cmscp_endpInput {
	void* auxdata;
	double initialtime;
	double* initialstate;
	double finaltime;
	double* finalstate;
	double* parameter;
}cmscp_endpInput;

typedef struct cmscp_linkInput {
	void* auxdata;  // auxdataǸأȲȷ
	double leftFinTime;
	double* leftFinState;
	double* leftParameter;
	double rightIniTime;
	double* rightIniState;
	double* rightParameter;
}cmscp_linkInput;

typedef struct cmscp_objEventInputPhase {
	double initialtime;
	double finaltime;
	double* initialstate;
	double* finalstate;
	double* parameter;
}cmscp_objEventInputPhase;

typedef struct cmscp_objEventInput {
	void* auxdata;  // auxdataǸأȲȷ
	cmscp_objEventInputPhase** phase;
}cmscp_objEventInput;

typedef void (*cmscp_continuous)(double*, double*, cmscp_contInput*);
typedef void (*cmscp_endpoint)(double*, cmscp_endpInput*);
typedef void (*cmscp_linkage)(double*, cmscp_linkInput*);
typedef void (*cmscp_objEvent)(double*, double*, cmscp_objEventInput*);
typedef void (*cmscp_objEventDepend)(intDemat*);
typedef void (*cmscp_contDepend)(intDemat*, int, void*);
typedef void (*cmscp_endpDepend)(intDemat*, int, void*);
typedef void (*cmscp_linkDepend)(intDemat*, int, void*);
typedef void (*cmscp_getIniRefTraj)(cmscp_trajInfo**, void*);
typedef int* (*cmscp_stopCondition)(int, cmscp_trajInfo**, cmscp_trajInfo**, void*);
typedef void (*cmscp_updateMeshInfo)(int, cmscp_trajInfo**, cmscp_trajInfo**, void*);
typedef void (*cmscp_updateTrustInfo)(int, cmscp_trajInfo**, cmscp_trajInfo**, void*);
typedef void (*cmscp_updateRefTraj)(cmscp_trajInfo**, cmscp_trajInfo**, void*);


typedef struct cmscp_functionsPhase {
	cmscp_continuous continuous;
	cmscp_endpoint endpoint;
	cmscp_linkage linkage;
}cmscp_functionsPhase;

typedef struct cmscp_functions {
	/* κ */
	cmscp_functionsPhase** phase;

	/* Ŀ꺯¼ */
	cmscp_objEvent objEvent;

	/* ֶϡģʽԺ */
	cmscp_objEventDepend objEventDepend;
	cmscp_contDepend contDepend;
	cmscp_endpDepend endpDepend;
	cmscp_linkDepend linkDepend;

	/* Ի躯 */
	cmscp_getIniRefTraj getIniRefTraj;
	cmscp_stopCondition stopCondition;
	cmscp_updateMeshInfo updateMeshInfo;
	cmscp_updateTrustInfo updateTrustInfo;
	cmscp_updateRefTraj updateRefTraj;
}cmscp_functions;

/* ÿεɢ */
typedef struct cmscp_mesh {
	int num;
	double* node;
}cmscp_mesh;

/* òṹ */
typedef struct cmscp_setup {
	void* auxdata; // ȷͣÿָ
	int numPhase; // ֶ
	char* sparseModel; // ϡģʽ
	double derStep; // 󵼲
	cmscp_scp* scpInfo; // ͹Ż
	//cmscp_functions* functions;
	cmscp_mesh** oldMesh;
	cmscp_mesh** mesh;
	cmscp_trust* trust;
	cmscp_dimension* dimension;
	cmscp_functions* functions;
	cmscp_bound* bounds;
}cmscp_setup;



int cmscp(cmscp_trajInfo** optTraj, cmscp_setup* setup);




