#pragma once
#include "cmscp.h"
#include "cmscp_math.h"
#include <math.h>

/*  */
typedef struct cmscp_nzPos {
	int* idxRow;
	int* ptrCol;
	int* ptrRow;
	int* idxCol;
	int numRow;
	int numCol;
}cmscp_nzPos;

typedef struct cmscp_nzPos_cont {
	cmscp_nzPos* state;
	cmscp_nzPos* control;
	cmscp_nzPos* parameter;
}cmscp_nzPos_cont;

typedef struct cmscp_nzPos_endp {
	cmscp_nzPos* iniState;
	cmscp_nzPos* finState;
	cmscp_nzPos* iniTime;
	cmscp_nzPos* finTime;
	cmscp_nzPos* parameter;
}cmscp_nzPos_endp;

typedef struct cmscp_nzPos_link {
	cmscp_nzPos* leftStatef;
	cmscp_nzPos* leftTf;
	cmscp_nzPos* leftParameter;
	cmscp_nzPos* rightState0;
	cmscp_nzPos* rightT0;
	cmscp_nzPos* rightParameter;
}cmscp_nzPos_link;

typedef struct cmscp_sparseInfo {
	cmscp_nzPos_cont** contNzPos;
	cmscp_nzPos_endp** objEventNzPos;
	cmscp_nzPos_endp** endpNzPos;
	cmscp_nzPos_link** linkNzPos;
}cmscp_sparseInfo;

/*  */
void getSparseInfo(cmscp_sparseInfo** sparseInfo0, cmscp_trajInfo** refTraj, cmscp_setup* setup); // ȡϡϢ
void mallocSparseInfo(cmscp_sparseInfo** sparseInfo0, int numPhase); // ռĺ
void intDematNzPos(int* demat, int numRow, int numCol, int** ptrRow0, int** idxCol0, int** idxRow0, int** ptrCol0); // ȡܾķԶλ
void intRcsToCcs(int* ptrRow, int* idxCol, int* valueRcs, int numRow, int numCol, int* idxRow, int* ptrCol, int* valueCcs); //RCSѹʽתCCSѹ
void floatRcsToCcs(int* ptrRow, int* idxCol, double* valueRcs, int numRow, int numCol, int* idxRow, int* ptrCol, double* valueCcs); // RCSѹʽתCCSѹ
void sparseInfoObjEvent(cmscp_sparseInfo** sparseInfo, cmscp_trajInfo** refTraj, cmscp_setup* setup); // ȡĿ꺯¼ԼϡϢ
void sparseInfoCont(cmscp_sparseInfo** sparseInfo, cmscp_trajInfo** refTraj, cmscp_setup* setup); // ȡкѹʽϡϢ
void sparseInfoEndp(cmscp_sparseInfo** sparseInfo0, cmscp_trajInfo** refTraj, cmscp_setup* setup);// ȡ˵㺯кѹʽϡϢ
void sparseInfoLink(cmscp_sparseInfo** sparseInfo0, cmscp_trajInfo** refTraj, cmscp_setup* setup);// ȡνӺкѹʽϡϢ