#include "coordinates.h"

/* ת */
void rot_x(demat* M, double alf) {
	//1Ԫ
	M->v[0] = 1;
	M->v[1] = 0;
	M->v[2] = 0;
	//2Ԫ
	M->v[3] = 0;
	M->v[4] = cos(alf);
	M->v[5] = sin(alf);
	//3Ԫ
	M->v[6] = 0;
	M->v[7] = -sin(alf);
	M->v[8] = cos(alf);
}

void rot_y(demat* M, double alf) {

	//1Ԫ
	M->v[0] = cos(alf);
	M->v[1] = 0;
	M->v[2] = -sin(alf);
	//2Ԫ
	M->v[3] = 0;
	M->v[4] = 1;
	M->v[5] = 0;
	//3Ԫ
	M->v[6] = sin(alf);
	M->v[7] = 0;
	M->v[8] = cos(alf);
}

void rot_z(demat* M, double alf) {

	//1Ԫ
	M->v[0] = cos(alf);
	M->v[1] = sin(alf);
	M->v[2] = 0;
	//2Ԫ
	M->v[3] = -sin(alf);
	M->v[4] = cos(alf);
	M->v[5] = 0;
	//3Ԫ
	M->v[6] = 0;
	M->v[7] = 0;
	M->v[8] = 1;
}

/* ɻתĸϵֱӵת */
void C_A2B(demat* M, double phi_T, double psi_T, double gamma_T) {
	// ػ߷ϵϵ
	// phi_T, psi_T, gamma_T: 321ת򣬷عϵϵ̬;
	// ת321
	demat* M1, * M2;
	M1 = createDeMat(3, 3);
	M2 = createDeMat(3, 3);
	rot_z(M1, phi_T);
	rot_y(M, psi_T);
	denseMM(M2, M, M1);
	rot_x(M1, gamma_T);
	denseMM(M, M1, M2);
	freeDeMat(M1, 2);
	freeDeMat(M2, 2);
}

void C_A2O(demat* M, double A0, double phi0, double T) {
	// عϵϵ
	// A0 ʼλ
	// phi0 ʼĻߵγ
	// Tӽϵʱķʱ
	double we;
	demat* M1, * M2;
	we = 7.272205216643040e-05; // תٶȣrad / s
	M1 = createDeMat(3, 3);
	M2 = createDeMat(3, 3);
	C_O2E(M1, A0, phi0);
	rot_z(M, we * T);
	denseMM(M2, M, M1);
	denseMtM(M, M1, M2);
	freeDeMat(M1, 2);
	freeDeMat(M2, 2);
}

void C_En2T(demat* M, double phi0, double phi, double dlambda) {
	// ϵϵ֮ת
	// phi0  ϵԭĵĻߵγ
	// phi  ϵԭĵγ
	// dlambda  Ȳ
	demat* M1, * M2;
	M1 = createDeMat(3, 3);
	M2 = createDeMat(3, 3);
	rot_z(M1, phi0);
	rot_x(M, dlambda);
	denseMM(M2, M, M1);
	rot_z(M1, -phi);
	denseMM(M, M1, M2);
	freeDeMat(M1, 2);
	freeDeMat(M2, 2);
}

void C_H2B(demat* M, double nv, double beta, double alpha) {
	// ٶϵϵ֮ת
	// ת123ת
	// nv
	// beta໬
	// alpha: 
	demat* M1, * M2;
	M1 = createDeMat(3, 3);
	M2 = createDeMat(3, 3);
	rot_x(M1, nv);
	rot_y(M, beta);
	denseMM(M2, M, M1);
	rot_z(M1, alpha);
	denseMM(M, M1, M2);
	freeDeMat(M1, 2);
	freeDeMat(M2, 2);
}

void C_O2E(demat* M, double A0, double phi0) {
	// ϵϵ
	// A0 ʼλ
	// phi0 ʼĻߵγ
	demat* M1, * M2;
	M1 = createDeMat(3, 3);
	M2 = createDeMat(3, 3);
	rot_y(M1, A0 + PI / 2);
	rot_x(M, -phi0);
	denseMM(M2, M, M1);
	rot_z(M1, PI / 2);
	denseMM(M, M1, M2);
	freeDeMat(M1, 2);
	freeDeMat(M2, 2);
}

void C_O2En(demat* M, double A0) {
	// ϵϵ֮ת
	// A0ʼλ
	rot_y(M, A0);
}

void C_T2H(demat* M, double sigma, double theta) {
	// ϵٶϵ֮ת
	// ת23ת
	// sigmaغλ
	// thetaٶ
	demat* M1, * M2;
	M1 = createDeMat(3, 3);
	M2 = createDeMat(3, 3);
	rot_y(M1, sigma);
	rot_z(M2, theta);
	denseMM(M, M2, M1);
	freeDeMat(M1, 2);
	freeDeMat(M2, 2);
}
void C_V2B(demat* M, double beta, double alpha) {
	// ٶϵϵ֮ת
	// ת23
	// beta: ໬
	// alpha : 
	demat* M1, * M2;
	M1 = createDeMat(3, 3);
	M2 = createDeMat(3, 3);
	rot_y(M1, alpha);
	rot_z(M2, beta);
	denseMM(M, M2, M1);
	freeDeMat(M1, 2);
	freeDeMat(M2, 2);
}

void A_H2B1(double* alpha, double* beta, double* nu,
	double sigma, double theta,
	double lat, double lon,
	double phi_T, double psi_T, double gamma_T,
	double A0, double lon0, double phi0, double T) {
	// alpha, beta, nu: ໬, , 
	//÷ʽ1ðٶϵHϵB֮ŷ
	//phi_T, psi_T, gamma_T: 321ת򣬷عϵϵ̬;
	//theta:ٶ;
	//sigma: ĵغλ
	//lon : ǰ
	//lat : ǰγ
	//A0 : ߷ϵķλ
	//lon0 : ߷ϵԭ㾭ȡȡϵô
	//phi0 : ߷ϵԭߵγȡȡϵô
	//T : ӽϵķʱ
	demat* M1, * M2, * M3;
	M1 = createDeMat(3, 3);
	M2 = createDeMat(3, 3);
	M3 = createDeMat(3, 3);
	C_A2O(M1, A0, phi0, T);
	C_A2B(M3, phi_T, psi_T, gamma_T);
	denseMMt(M2, M3, M1); // M2 = C_O2B
	C_O2En(M1, A0);
	denseMMt(M3, M1, M2); // M3 = C_B2En
	C_En2T(M1, phi0, lat, lon - lon0);
	denseMM(M2, M1, M3); // M2 = C_B2T
	C_T2H(M1, sigma, theta);
	denseMM(M3, M1, M2); // M3 = C_B2H
	beta[0] = asin(M3->v[2]);
	alpha[0] = atan2(-M3->v[1], M3->v[0]);
	nu[0] = atan2(-M3->v[5], M3->v[8]);
	freeDeMat(M1, 2);
	freeDeMat(M2, 2);
	freeDeMat(M3, 2);
}