#include "denseBlas.h"

/* һ󣬷µľռ */
demat* createDeMat(int m, int n) // mУnУnnzԪ
{
	int numEle;
	numEle = m * n;
	double* v = (double*)malloc(numEle * sizeof(double));		// ȫԪ
	return assembleDeMat(m, n, v);
}

/* пռװһ */
demat* assembleDeMat(int m, int n, double* v) // mУnУvΪԪأ
{
	demat* M = (demat*)malloc(sizeof(demat));
	M->m = m;
	M->n = n;
	M->v = v;
	return M;
}
/* ͷһܾռ */
void freeDeMat(demat* M, int level)
{
	if (M->v) {
		free(M->v);
	}
	if (level == 2) {
		free(M);
	}
}

/* 2 */
double cmscp_norm2(double* v, int n) {
	int i;
	double normsquare = 0;
	for (i = 0; i < n; i++) {
		normsquare += v[i] * v[i];
	}
	return sqrt(normsquare);
}

/* ܾ */
void denseMM(demat* matOut, demat* matLeftIn, demat* matRightIn) {
	/*  */
	int mMatOut, nMatOut, mMatLeftIn, nMatLeftIn, mMatRightIn, nMatRightIn, i, j, k, p1, p2, p3;
	double* vMatOut, * vMatLeftIn, * vMatRightIn;

	/* άϢ */
	mMatOut = matLeftIn->m;
	nMatOut = matRightIn->n;
	mMatLeftIn = matLeftIn->m;
	nMatLeftIn = matLeftIn->n;
	mMatRightIn = matRightIn->m;
	nMatRightIn = matRightIn->n;

	/* Ԫ */
	vMatOut = matOut->v;
	vMatLeftIn = matLeftIn->v;
	vMatRightIn = matRightIn->v;

	/*  */
	for (i = 0; i < mMatOut; i++) {
		for (j = 0; j < nMatOut; j++) {
			p1 = i * mMatOut + j; // matOutеڣi,jԪ洢ʽеλ
			vMatOut[p1] = 0;
			for (k = 0; k < nMatLeftIn; k++) {
				p2 = i * mMatLeftIn + k; // matLeftInеڣi,kԪ洢ʽеλ
				p3 = k * mMatRightIn + j; // matRightInеڣk,jԪ洢ʽеλ
				vMatOut[p1] += vMatLeftIn[p2] * vMatRightIn[p3];
			}
		}
	}
}


/* ܾת */
void denseMtM(demat* matOut, demat* matLeftIn, demat* matRightIn) {
	/*  */
	int mMatOut, nMatOut, mMatLeftIn, nMatLeftIn, mMatRightIn, nMatRightIn, i, j, k, p1, p2, p3;
	double* vMatOut, * vMatLeftIn, * vMatRightIn;

	/* άϢ */
	mMatOut = matLeftIn->m;
	nMatOut = matRightIn->n;
	mMatLeftIn = matLeftIn->m;
	nMatLeftIn = matLeftIn->n;
	mMatRightIn = matRightIn->m;
	nMatRightIn = matRightIn->n;

	/* Ԫ */
	vMatOut = matOut->v;
	vMatLeftIn = matLeftIn->v;
	vMatRightIn = matRightIn->v;

	/*  */
	for (i = 0; i < mMatOut; i++) {
		for (j = 0; j < nMatOut; j++) {
			p1 = i * mMatOut + j; // matOutеڣi,jԪ洢ʽеλ
			vMatOut[p1] = 0;
			for (k = 0; k < nMatLeftIn; k++) {
				p2 = k * mMatLeftIn + i; // matLeftInתþеڣi,kԪ洢ʽеλ
				p3 = k * mMatRightIn + j; // matRightInеڣk,jԪ洢ʽеλ
				vMatOut[p1] += vMatLeftIn[p2] * vMatRightIn[p3];
			}
		}
	}
}


/* ܾת */
void denseMMt(demat* matOut, demat* matLeftIn, demat* matRightIn) {
	/*  */
	int mMatOut, nMatOut, mMatLeftIn, nMatLeftIn, mMatRightIn, nMatRightIn, i, j, k, p1, p2, p3;
	double* vMatOut, * vMatLeftIn, * vMatRightIn;

	/* άϢ */
	mMatOut = matLeftIn->m;
	nMatOut = matRightIn->n;
	mMatLeftIn = matLeftIn->m;
	nMatLeftIn = matLeftIn->n;
	mMatRightIn = matRightIn->m;
	nMatRightIn = matRightIn->n;

	/* Ԫ */
	vMatOut = matOut->v;
	vMatLeftIn = matLeftIn->v;
	vMatRightIn = matRightIn->v;

	/*  */
	for (i = 0; i < mMatOut; i++) {
		for (j = 0; j < nMatOut; j++) {
			p1 = i * mMatOut + j; // matOutеڣi,jԪ洢ʽеλ
			vMatOut[p1] = 0;
			for (k = 0; k < nMatLeftIn; k++) {
				p2 = i * mMatLeftIn + k; // matLeftInеڣi,kԪ洢ʽеλ
				p3 = j * mMatRightIn + k; // matRightInתеڣk,jԪ洢ʽеλ
				vMatOut[p1] += vMatLeftIn[p2] * vMatRightIn[p3];
			}
		}
	}
}

/* ܾ */
void denseMV(double* vecOut, demat* matLeftIn, double* vecRightIn, int sign, int newVecOut) {
	/*  */
	int mMatLeftIn, nMatLeftIn, i, j, p;
	double* vMatLeftIn;

	/* άϢ */
	mMatLeftIn = matLeftIn->m;
	nMatLeftIn = matLeftIn->n;

	/* Ԫ */
	vMatLeftIn = matLeftIn->v;

	if (newVecOut == 1) // 
	{
		for (i = 0; i < mMatLeftIn; i++)
		{
			vecOut[i] = 0;
		}
	}
	if (sign == 1) // ӷ
	{
		for (i = 0; i < mMatLeftIn; i++)
		{
			for (j = 0; j < nMatLeftIn; j++)
			{
				p = i * mMatLeftIn + j;
				vecOut[i] += vMatLeftIn[p] * vecRightIn[j];
			}
		}
	}
	else // 
	{
		for (i = 0; i < mMatLeftIn; i++)
		{
			for (j = 0; j < nMatLeftIn; j++)
			{
				p = i * mMatLeftIn + j;
				vecOut[i] -= vMatLeftIn[p] * vecRightIn[j];
			}
		}
	}
}


/* ܾ */
void denseMtV(double* vecOut, demat* matLeftIn, double* vecRightIn, int sign, int newVecOut) {
	/*  */
	int mMatLeftIn, nMatLeftIn, i, j, p;
	double* vMatLeftIn;

	/* άϢ */
	mMatLeftIn = matLeftIn->m;
	nMatLeftIn = matLeftIn->n;

	/* Ԫ */
	vMatLeftIn = matLeftIn->v;

	if (newVecOut == 1) // 
	{
		for (j = 0; j < mMatLeftIn; j++)
		{
			vecOut[j] = 0;
		}
	}
	if (sign == 1) // ӷ
	{
		for (i = 0; i < mMatLeftIn; i++)
		{
			for (j = 0; j < nMatLeftIn; j++)
			{
				p = i * mMatLeftIn + j; // matLeftInתþ(j,i)Ԫ
				vecOut[j] += vMatLeftIn[p] * vecRightIn[i];
			}
		}
	}
	else // 
	{
		for (i = 0; i < mMatLeftIn; i++)
		{
			for (j = 0; j < nMatLeftIn; j++)
			{
				p = i * mMatLeftIn + j; // matLeftInתþ(j,i)Ԫ
				vecOut[j] -= vMatLeftIn[p] * vecRightIn[i];
			}
		}
	}
}


/* ֵ */
void denseScaV(double* vecOut, double scaIn, double* vecIn, int length) {
	/*  */
	int i;
	for (i = 0; i < length; i++)
	{
		vecOut[i] = scaIn * vecIn[i];
	}
}

/* ֵ */
void denseScaPlusVec(double* vecOut, double scaIn, double* vecIn, int length) {
	/*  */
	int i;
	for (i = 0; i < length; i++)
	{
		vecOut[i] = scaIn + vecIn[i];
	}
}