#pragma once
#include "cmscp.h"
#include <math.h>
#include "denseBlas.h"
/* 궨 */
#define PI 3.141592653589793
#define r2d (180/PI)
#define d2r (PI/180)

typedef struct cmscp_integTraj {
	double* time;
	demat* state;
	demat* control;
	int length;
} cmscp_integTraj;

typedef struct cmscp_scales {
	double length;
	double speed;
	double time;
	double acceleration;
	double mass;
	double force;
	double area;
	double volume;
	double density;
	double gravparam;
} cmscp_scales;

typedef struct cmscp_auxdata {
	cmscp_scales* scales;
	double omega;
	double mu;
	double ae;
	double be;
	double e;
	double S;
	double mass1;
	double mass2;
	double Re;
	double g0;
	double Isp;
	double thrust;
	double launchLon;
	double launchLat;
	double launchB;
	double launchA;
	double phiT0;
	double psiT0;
	double gammaT0;
	double x0[8];
} cmscp_auxdata;