#include "example1.h"
#include "cmscp.h"
#include "denseBlas.h"
#include "coordinates.h"
#include "dynInteg.h"
#include "numericalFunctions.h"
#include "constaints.h"
#include "userFunctions.h"
#include "mallocStruct.h"
#include "freeTrajInfo.h"
#include "freeSetup.h"
#include "ecos.h"
#include "timer.h"

#ifndef LUOYC20220810  //open cache include files
#include <c6x.h>
//#include <ti/csl/csl_cache.h>
//#include <ti/csl/csl_cacheAux.h>
#endif

int main(void) {

	// ʱʼ
#ifndef LUOYC20220812   // use register to compute time
	/* Initialize timer for clock */
	 clock_t start_time, end_time, use_time, cycle_over_time;
	 TSCL = 0, TSCH = 0;
	 /* Compute the overhead of calling _itoll(TSCH, TSCL) twice to get timing info  */
	 start_time = _itoll(TSCH, TSCL);
	 end_time = _itoll(TSCH, TSCL);
	 cycle_over_time = end_time - start_time; //ĴȡʱУ׼
	 printf("cycle_over_time = %d\n", cycle_over_time);

	 start_time = _itoll(TSCH, TSCL);
	 printf("start: %d \n", start_time);

#endif


	/*  */
	int idxTarget, idxData, isScale, isIntegOver, iphase, numPhase, numState, numControl, numParameter, numPathNl, numRowPathSoc, numEndpNl, numRowEndpSoc, numLinkNl, numRowLinkSoc, numEventNl, numRowEventSoc;
	double ts, rads, lons, lats, VxVyVzs[3], phiT0, psiT0, gammaT0, A0, lon0, lat0, B0, ae, alphae, e, be, earthRadius, gravParam, earthRotRate, g0, mass1, mass2, Sr, Isp, thrust, speeds, dlambda, VsT[3], fpasT, azisT, xs[8], integStepSize, newState[8], oldState[8], u[2], tempWork[37], time, downRange, crossRange;
	timer timer;
	demat* O2En, * En2T, * O2T;
	cmscp_scales* scales;
	cmscp_auxdata* auxdata;
	cmscp_bound* bounds;
	cmscp_dimension* dimension;
	cmscp_trust* trust;
	cmscp_functions* functions;
	cmscp_mesh** mesh;
	cmscp_scp* scpInfo;
	cmscp_setup* setup;
	cmscp_trajInfo** optTraj;

	/*        йе            */
	// ص
#ifdef SET_6000
	idxTarget = 2; // ׼м㣬С6000׼һ㣬6000׼3
	idxData = 1; // ϵ״̬
#else
	idxTarget = 3; // Ϊ8000km
	idxData = 3; // ϵ״̬
#endif

	if (idxTarget == 1)
	{
		downRange = 4200; // ݳ̣
		crossRange = -180; // ̣
	}
	else if (idxTarget == 2)
	{
		downRange = 6000; // ݳ̣
		crossRange = -200; // ̣
	}
	else if (idxTarget == 3)
	{
		downRange = 8000; // ݳ̣
		crossRange = -280; // ̣
	}
	if (idxData == 1)
	{
		ts = 380;// ʱ
		rads = 6546704.2706;// ߶(m)
		lons = 119.4725696 * d2r;// 
		lats = 16.9196739 * d2r;// γ
		VxVyVzs[0] = 5477.6870; // ϵеٶȷ (m/s)
		VxVyVzs[1] = -664.8871;
		VxVyVzs[2] = 186.7492;
		phiT0 = -5.6098 * d2r; // ϵе̬
		psiT0 = -2 * d2r; // ϵе̬ƫ
		gammaT0 = 0 * d2r; // ϵе̬ת
	}
	else if (idxData == 2)
	{
		ts = 409;// ʱ
		rads = 6550185.5290;// ߶(m)
		lons = 120.9117086 * d2r;// 
		lats = 16.4206336 * d2r;// γ
		VxVyVzs[0] = 5972.4886; // ϵеٶȷ (m/s)
		VxVyVzs[1] = -963.2659;
		VxVyVzs[2] = 216.4701;
		phiT0 = -8.9470 * d2r; // ϵе̬
		psiT0 = -2 * d2r; // ϵе̬ƫ
		gammaT0 = 0 * d2r; // ϵе̬ת
	}
	else if (idxData == 3)
	{
		ts = 480;// ʱ
		rads = 6552991.9656;// ߶(m)
		lons = 124.8990660 * d2r;// 
		lats = 14.9596008 * d2r;// γ
		VxVyVzs[0] = 6638.6054; // ϵеٶȷ (m/s)
		VxVyVzs[1] = -1668.4212;
		VxVyVzs[2] = 266.9431;
		phiT0 = -10.5508 * d2r; // ϵе̬
		psiT0 = -2 * d2r; // ϵе̬ƫ
		gammaT0 = 0 * d2r; // ϵе̬ת
	}
	else if (idxData == 4)
	{
		ts = 521;// ʱ
		rads = 6552328.8253;// ߶(m)
		lons = 127.2743085 * d2r;// 
		lats = 14.0392779 * d2r;// γ
		VxVyVzs[0] = 6664.7385; // ϵеٶȷ (m/s)
		VxVyVzs[1] = -2016.3414;
		VxVyVzs[2] = 279.8585;
		phiT0 = -10.2110 * d2r; // ϵе̬
		psiT0 = -2 * d2r; // ϵе̬ƫ
		gammaT0 = 0 * d2r; // ϵе̬ת
	}
	else if (idxData == 5)
	{
		ts = 535;// ʱ
		rads = 6551867.9995;// ߶(m)
		lons = 128.0899647 * d2r;// 
		lats = 13.7150515 * d2r;// γ
		VxVyVzs[0] = 6671.2103; // ϵеٶȷ (m/s)
		VxVyVzs[1] = -2133.9773;
		VxVyVzs[2] = 284.0635;
		phiT0 = -10.0950 * d2r; // ϵе̬
		psiT0 = -2 * d2r; // ϵе̬ƫ
		gammaT0 = 0 * d2r; // ϵе̬ת
	}
	// 
	A0 = 105 * d2r;// 㷽λǣԭ110.5, 105
	lon0 = 110.9553770 * d2r;// 
	lat0 = 19.4972490 * d2r;// γ
	B0 = 19.6186476 * d2r;// ϵƽ棬õγ

	// 
	ae = 6378140;// 򳤰
	alphae = 1 / 298.257;// 
	e = 1 - alphae;// ƫ
	be = ae * e;// ̰
	earthRadius = 6371.393 * 1000;// ƽ뾶(m)
	gravParam = 3.98603e14;// (m ^ 3 / s ^ 2)
	earthRotRate = 2 * PI / (24.0 * 60.0 * 60.0);// תٶ
	g0 = 9.80665;// ƽƽٶȣm / s ^ 2

	// 
	mass1 = 23000.0;// ƽ + ɴ
	mass2 = 7000;// ɴ
	Sr = 13.202;// ο
	Isp = 305;// ȳ
	thrust = 15000 * 4;// 

	// Ĺһ
	isScale = 1;
	scales = (cmscp_scales*)malloc(sizeof(cmscp_scales));
	if (isScale == 1)
	{
		scales->length = earthRadius;
		scales->speed = sqrt(gravParam / scales->length);
		scales->time = scales->length / scales->speed;
		scales->acceleration = scales->speed / scales->time;
		scales->mass = mass1;
		scales->force = scales->mass * scales->acceleration;
		scales->area = scales->length * scales->length;
		scales->volume = scales->area * scales->length;
		scales->density = scales->mass / scales->volume;
		scales->gravparam = scales->acceleration * scales->area;
	}
	else
	{
		scales->length = 1.0;
		scales->speed = 1.0;
		scales->time = 1.0;
		scales->acceleration = 1.0;
		scales->mass = 1.0;
		scales->force = 1.0;
		scales->area = 1.0;
		scales->volume = 1.0;
		scales->density = 1.0;
		scales->gravparam = 1.0;
	}
	/* ٶϵжѧ̳ʼ״̬ */
	O2En = createDeMat(3, 3);
	En2T = createDeMat(3, 3);
	O2T = createDeMat(3, 3);
	speeds = cmscp_norm2(VxVyVzs, 3);// ʼٶȴС
	C_O2En(O2En, A0); // 䣨أϵϵ֮ת
	// 뵽ϵת
	dlambda = lons - lon0; // Ȳ
	C_En2T(En2T, B0, lats, dlambda);
	denseMM(O2T, En2T, O2En);
	// ϵеٶȷ
	denseMV(VsT, O2T, VxVyVzs, 1, 1);
	// ϵٶǣֻ231һת
	fpasT = asin(VsT[1] / speeds);
	// ϵλǣұΪ
	azisT = atan2(-VsT[2], VsT[0]);
	// ͷſռ
	freeDeMat(O2En, 2);
	freeDeMat(En2T, 2);
	freeDeMat(O2T, 2);
	// ʼ״̬
	xs[0] = rads / scales->length;
	xs[1] = lons;
	xs[2] = lats;
	xs[3] = speeds / scales->speed;
	xs[4] = fpasT;
	xs[5] = azisT;
	xs[6] = mass1 / scales->mass;
	xs[7] = ts / scales->time;

	// ѧҺ٣
	auxdata = (cmscp_auxdata*)malloc(sizeof(cmscp_auxdata));
	auxdata->scales = scales;
	auxdata->omega = earthRotRate;
	auxdata->mu = gravParam;
	auxdata->ae = ae;
	auxdata->be = be;
	auxdata->e = e;
	auxdata->S = Sr;
	auxdata->mass1 = mass1;
	auxdata->mass2 = mass2;
	auxdata->Re = earthRadius;
	auxdata->g0 = g0;
	auxdata->Isp = Isp;
	auxdata->thrust = thrust;
	auxdata->launchLon = lon0;
	auxdata->launchLat = lat0;
	auxdata->launchB = B0;// ϵƽ棬õγ
	auxdata->launchA = A0;
	auxdata->phiT0 = phiT0;
	auxdata->psiT0 = psiT0;
	auxdata->gammaT0 = gammaT0;

	// ѧ֣1ιǸֹ
	copyFloatVec(xs, oldState, 8, 0);
	isIntegOver = 0;
	integStepSize = 0.5 / scales->time;
	while (isIntegOver == 0)
	{
		// 
		u[0] = phiT0;
		u[1] = psiT0;
		// ״̬
		computeInteg(newState, dynInteg1, oldState, u, NULL, auxdata, 8, 2, 0, 5, tempWork, integStepSize, 3);
		copyFloatVec(newState, oldState, 8, 0);
		// ֽ־λ
		if ((oldState[7] - xs[7] > 12.5 / scales->time) || oldState[7] > 3000 / scales->time)
		{
			isIntegOver = 1;
		}
	}
	copyFloatVec(oldState, auxdata->x0, 8, 0);
	/*           ͹Ż㷨           */
	numPhase = 5;
	numEventNl = 0;
	numRowEventSoc = 0;
	// Լ߽ռ
	// ռ
	bounds = (cmscp_bound*)malloc(sizeof(cmscp_bound));
	mallocBound(bounds, numPhase, numEventNl, numRowEventSoc);
	// һεĿռ
	iphase = 0;
	// һεά
	numState = 8;
	numControl = 2;
	numParameter = 2;
	numPathNl = 3;
	numRowPathSoc = 0;
	numEndpNl = 3;
	numRowEndpSoc = 0;
	numLinkNl = 8;
	numRowLinkSoc = 0;
	mallocBoundPhase(bounds, iphase, numState, numControl, numParameter, numPathNl, numRowPathSoc, numEndpNl, numRowEndpSoc, numLinkNl, numRowLinkSoc, numPhase);
	// Լ߽縳ֵ
	bounds->phase[iphase]->initialtime->lower = auxdata->x0[7];
	bounds->phase[iphase]->initialtime->upper = auxdata->x0[7];
	bounds->phase[iphase]->finaltime->lower = auxdata->x0[7] + 0 / scales->time;
	bounds->phase[iphase]->finaltime->upper = auxdata->x0[7] + 3000.0 / scales->time;
	copyFloatVec(auxdata->x0, bounds->phase[iphase]->initialstate->lower, numState, 0);
	copyFloatVec(auxdata->x0, bounds->phase[iphase]->initialstate->upper, numState, 0);
	bounds->phase[iphase]->state->lower[0] = (8.0 * 1000.0 + auxdata->be) / scales->length;
	bounds->phase[iphase]->state->lower[1] = xs[1];
	bounds->phase[iphase]->state->lower[2] = -80.0 * d2r;
	bounds->phase[iphase]->state->lower[3] = 100.0 / scales->speed;
	bounds->phase[iphase]->state->lower[4] = -80.0 * d2r;
	bounds->phase[iphase]->state->lower[5] = -300.0 * d2r;
	bounds->phase[iphase]->state->lower[6] = mass2 / scales->mass;
	bounds->phase[iphase]->state->lower[7] = -INF;
	bounds->phase[iphase]->state->upper[0] = (200.0 * 1000.0 + auxdata->ae) / scales->length;
	bounds->phase[iphase]->state->upper[1] = xs[1] + 180.0 * d2r;
	bounds->phase[iphase]->state->upper[2] = 90.0 * d2r;
	bounds->phase[iphase]->state->upper[3] = 1000.0 / scales->speed + xs[3];
	bounds->phase[iphase]->state->upper[4] = 10.0 * d2r;
	bounds->phase[iphase]->state->upper[5] = 300.0 * d2r;
	bounds->phase[iphase]->state->upper[6] = mass1 / scales->mass;
	bounds->phase[iphase]->state->upper[7] = INF;
	bounds->phase[iphase]->finalstate->lower[0] = (8.0 * 1000.0 + auxdata->be) / scales->length;
	bounds->phase[iphase]->finalstate->lower[1] = xs[1];
	bounds->phase[iphase]->finalstate->lower[2] = -80.0 * d2r;
	bounds->phase[iphase]->finalstate->lower[3] = 100.0 / scales->speed;
	bounds->phase[iphase]->finalstate->lower[4] = -80.0 * d2r;
	bounds->phase[iphase]->finalstate->lower[5] = -300.0 * d2r;
	bounds->phase[iphase]->finalstate->lower[6] = mass2 / scales->mass;
	bounds->phase[iphase]->finalstate->lower[7] = -INF;
	bounds->phase[iphase]->finalstate->upper[0] = (200.0 * 1000.0 + auxdata->ae) / scales->length;
	bounds->phase[iphase]->finalstate->upper[1] = xs[1] + 180.0 * d2r;
	bounds->phase[iphase]->finalstate->upper[2] = 90.0 * d2r;
	bounds->phase[iphase]->finalstate->upper[3] = 1000.0 / scales->speed + xs[3];
	bounds->phase[iphase]->finalstate->upper[4] = 10.0 * d2r;
	bounds->phase[iphase]->finalstate->upper[5] = 300.0 * d2r;
	bounds->phase[iphase]->finalstate->upper[6] = mass1 / scales->mass;
	bounds->phase[iphase]->finalstate->upper[7] = INF;
	bounds->phase[iphase]->control->lower[0] = -180.0 * d2r;
	bounds->phase[iphase]->control->lower[1] = -89.0 * d2r;
	bounds->phase[iphase]->control->upper[0] = 180.0 * d2r;
	bounds->phase[iphase]->control->upper[1] = 89.0 * d2r;
	bounds->phase[iphase]->parameter->lower[0] = -INF;
	bounds->phase[iphase]->parameter->lower[1] = -INF;
	bounds->phase[iphase]->parameter->upper[0] = INF;
	bounds->phase[iphase]->parameter->upper[1] = INF;
	bounds->phase[iphase]->path->nl->lower[0] = 8.0 * 1000.0 / scales->length;
	bounds->phase[iphase]->path->nl->lower[1] = 0.0;
	bounds->phase[iphase]->path->nl->lower[2] = 0.0;
	bounds->phase[iphase]->path->nl->upper[0] = 200.0 * 1000.0 / scales->length;
	bounds->phase[iphase]->path->nl->upper[1] = 0.0;
	bounds->phase[iphase]->path->nl->upper[2] = 0.0;
	bounds->phase[iphase]->endpoint->nl->lower[0] = 30 / scales->time;
	bounds->phase[iphase]->endpoint->nl->lower[1] = 0.0;
	bounds->phase[iphase]->endpoint->nl->lower[2] = 0.0;
	bounds->phase[iphase]->endpoint->nl->upper[0] = 60 / scales->time;
	bounds->phase[iphase]->endpoint->nl->upper[1] = 0.0;
	bounds->phase[iphase]->endpoint->nl->upper[2] = 0.0;
	floatVecFillin(bounds->phase[iphase]->linkage->nl->lower, numLinkNl, 0);
	floatVecFillin(bounds->phase[iphase]->linkage->nl->upper, numLinkNl, 0);

	// 2εĿռ
	iphase = 1;
	// 2εά
	numState = 8;
	numControl = 2;
	numParameter = 2;
	numPathNl = 3;
	numRowPathSoc = 0;
	numEndpNl = 3;
	numRowEndpSoc = 2;
	numLinkNl = 8;
	numRowLinkSoc = 0;
	mallocBoundPhase(bounds, iphase, numState, numControl, numParameter, numPathNl, numRowPathSoc, numEndpNl, numRowEndpSoc, numLinkNl, numRowLinkSoc, numPhase);
	// Լ߽縳ֵ
	bounds->phase[iphase]->initialtime->lower = auxdata->x0[7];
	bounds->phase[iphase]->initialtime->upper = auxdata->x0[7] + 3000.0 / scales->time;
	bounds->phase[iphase]->finaltime->lower = auxdata->x0[7];
	bounds->phase[iphase]->finaltime->upper = auxdata->x0[7] + 3000.0 / scales->time;
	bounds->phase[iphase]->initialstate->lower[0] = (8.0 * 1000.0 + auxdata->be) / scales->length;
	bounds->phase[iphase]->initialstate->lower[1] = -360.0 * d2r;
	bounds->phase[iphase]->initialstate->lower[2] = -80.0 * d2r;
	bounds->phase[iphase]->initialstate->lower[3] = 100.0 / scales->speed;
	bounds->phase[iphase]->initialstate->lower[4] = -80.0 * d2r;
	bounds->phase[iphase]->initialstate->lower[5] = -300.0 * d2r;
	bounds->phase[iphase]->initialstate->lower[6] = mass2 / scales->mass;
	bounds->phase[iphase]->initialstate->lower[7] = -INF;
	bounds->phase[iphase]->initialstate->upper[0] = (200.0 * 1000.0 + auxdata->ae) / scales->length;
	bounds->phase[iphase]->initialstate->upper[1] = 360.0 * d2r;
	bounds->phase[iphase]->initialstate->upper[2] = 90.0 * d2r;
	bounds->phase[iphase]->initialstate->upper[3] = 10000.0 / scales->speed;
	bounds->phase[iphase]->initialstate->upper[4] = 10.0 * d2r;
	bounds->phase[iphase]->initialstate->upper[5] = 300.0 * d2r;
	bounds->phase[iphase]->initialstate->upper[6] = mass1 / scales->mass;
	bounds->phase[iphase]->initialstate->upper[7] = INF;
	bounds->phase[iphase]->state->lower[0] = (8.0 * 1000.0 + auxdata->be) / scales->length;
	bounds->phase[iphase]->state->lower[1] = -360.0 * d2r;
	bounds->phase[iphase]->state->lower[2] = -80.0 * d2r;
	bounds->phase[iphase]->state->lower[3] = 100.0 / scales->speed;
	bounds->phase[iphase]->state->lower[4] = -80.0 * d2r;
	bounds->phase[iphase]->state->lower[5] = -300.0 * d2r;
	bounds->phase[iphase]->state->lower[6] = mass2 / scales->mass;
	bounds->phase[iphase]->state->lower[7] = -INF;
	bounds->phase[iphase]->state->upper[0] = (200.0 * 1000.0 + auxdata->ae) / scales->length;
	bounds->phase[iphase]->state->upper[1] = 360.0 * d2r;
	bounds->phase[iphase]->state->upper[2] = 90.0 * d2r;
	bounds->phase[iphase]->state->upper[3] = 10000.0 / scales->speed;
	bounds->phase[iphase]->state->upper[4] = 10.0 * d2r;
	bounds->phase[iphase]->state->upper[5] = 300.0 * d2r;
	bounds->phase[iphase]->state->upper[6] = mass1 / scales->mass;
	bounds->phase[iphase]->state->upper[7] = INF;
	bounds->phase[iphase]->finalstate->lower[0] = (8.0 * 1000.0 + auxdata->be) / scales->length;
	bounds->phase[iphase]->finalstate->lower[1] = -360 * d2r;
	bounds->phase[iphase]->finalstate->lower[2] = -80 * d2r;
	bounds->phase[iphase]->finalstate->lower[3] = 100 / scales->speed;
	bounds->phase[iphase]->finalstate->lower[4] = -80 * d2r;
	bounds->phase[iphase]->finalstate->lower[5] = -300 * d2r;
	bounds->phase[iphase]->finalstate->lower[6] = mass2 / scales->mass;
	bounds->phase[iphase]->finalstate->lower[7] = -INF;
	bounds->phase[iphase]->finalstate->upper[0] = (200.0 * 1000.0 + auxdata->ae) / scales->length;
	bounds->phase[iphase]->finalstate->upper[1] = 360 * d2r;
	bounds->phase[iphase]->finalstate->upper[2] = 90 * d2r;
	bounds->phase[iphase]->finalstate->upper[3] = 10000 / scales->speed;
	bounds->phase[iphase]->finalstate->upper[4] = 10 * d2r;
	bounds->phase[iphase]->finalstate->upper[5] = 300 * d2r;
	bounds->phase[iphase]->finalstate->upper[6] = mass1 / scales->mass;
	bounds->phase[iphase]->finalstate->upper[7] = INF;
	
	// ƫ
	bounds->phase[iphase]->control->lower[0] = -180 * d2r;
	bounds->phase[iphase]->control->lower[1] = auxdata->psiT0;
	bounds->phase[iphase]->control->upper[0] = 180 * d2r;
	bounds->phase[iphase]->control->upper[1] = auxdata->psiT0;
	bounds->phase[iphase]->parameter->lower[0] = -INF;
	bounds->phase[iphase]->parameter->lower[1] = auxdata->psiT0;
	bounds->phase[iphase]->parameter->upper[0] = INF;
	bounds->phase[iphase]->parameter->upper[1] = auxdata->psiT0;

	bounds->phase[iphase]->path->nl->lower[0] = 8.0 * 1000.0 / scales->length;
	bounds->phase[iphase]->path->nl->lower[1] = 0.0;
	bounds->phase[iphase]->path->nl->lower[2] = 0.0;
	bounds->phase[iphase]->path->nl->upper[0] = 200.0 * 1000.0 / scales->length;
	bounds->phase[iphase]->path->nl->upper[1] = 0.0;
	bounds->phase[iphase]->path->nl->upper[2] = 0.0;
	bounds->phase[iphase]->endpoint->nl->lower[0] = 20.0 / scales->time;
	bounds->phase[iphase]->endpoint->nl->lower[1] = 0.0;
	bounds->phase[iphase]->endpoint->nl->lower[2] = 0.0;
	bounds->phase[iphase]->endpoint->nl->upper[0] = 300.0 / scales->time;
	bounds->phase[iphase]->endpoint->nl->upper[1] = 0.0;
	bounds->phase[iphase]->endpoint->nl->upper[2] = 0.0;
	bounds->phase[iphase]->endpoint->soc[0] = 360.0 / scales->speed;
	bounds->phase[iphase]->endpoint->soc[1] = 0.0;
	floatVecFillin(bounds->phase[iphase]->linkage->nl->lower, numLinkNl, 0);
	floatVecFillin(bounds->phase[iphase]->linkage->nl->upper, numLinkNl, 0);

	// 3εĿռ
	iphase = 2;
	// 3εά
	numState = 8;
	numControl = 2;
	numParameter = 2;
	numPathNl = 3;
	numRowPathSoc = 0;
	numEndpNl = 4;
	numRowEndpSoc = 0;
	numLinkNl = 7;
	numRowLinkSoc = 0;
	mallocBoundPhase(bounds, iphase, numState, numControl, numParameter, numPathNl, numRowPathSoc, numEndpNl, numRowEndpSoc, numLinkNl, numRowLinkSoc, numPhase);
	// Լ߽縳ֵ
	bounds->phase[iphase]->initialtime->lower = auxdata->x0[7];
	bounds->phase[iphase]->initialtime->upper = auxdata->x0[7] + 3000.0 / scales->time;
	bounds->phase[iphase]->finaltime->lower = auxdata->x0[7];
	bounds->phase[iphase]->finaltime->upper = auxdata->x0[7] + 3000.0 / scales->time;
	bounds->phase[iphase]->initialstate->lower[0] = (8.0 * 1000.0 + auxdata->be) / scales->length;
	bounds->phase[iphase]->initialstate->lower[1] = -360.0 * d2r;
	bounds->phase[iphase]->initialstate->lower[2] = -80.0 * d2r;
	bounds->phase[iphase]->initialstate->lower[3] = 100.0 / scales->speed;
	bounds->phase[iphase]->initialstate->lower[4] = -80.0 * d2r;
	bounds->phase[iphase]->initialstate->lower[5] = -300.0 * d2r;
	bounds->phase[iphase]->initialstate->lower[6] = mass2 / scales->mass;
	bounds->phase[iphase]->initialstate->lower[7] = -INF;
	bounds->phase[iphase]->initialstate->upper[0] = (200.0 * 1000.0 + auxdata->ae) / scales->length;
	bounds->phase[iphase]->initialstate->upper[1] = 360.0 * d2r;
	bounds->phase[iphase]->initialstate->upper[2] = 90.0 * d2r;
	bounds->phase[iphase]->initialstate->upper[3] = 10000.0 / scales->speed;
	bounds->phase[iphase]->initialstate->upper[4] = 10.0 * d2r;
	bounds->phase[iphase]->initialstate->upper[5] = 300.0 * d2r;
	bounds->phase[iphase]->initialstate->upper[6] = mass1 / scales->mass;
	bounds->phase[iphase]->initialstate->upper[7] = INF;
	bounds->phase[iphase]->state->lower[0] = (8.0 * 1000.0 + auxdata->be) / scales->length;
	bounds->phase[iphase]->state->lower[1] = -360.0 * d2r;
	bounds->phase[iphase]->state->lower[2] = -80.0 * d2r;
	bounds->phase[iphase]->state->lower[3] = 100.0 / scales->speed;
	bounds->phase[iphase]->state->lower[4] = -80.0 * d2r;
	bounds->phase[iphase]->state->lower[5] = -300.0 * d2r;
	bounds->phase[iphase]->state->lower[6] = mass2 / scales->mass;
	bounds->phase[iphase]->state->lower[7] = -INF;
	bounds->phase[iphase]->state->upper[0] = (200.0 * 1000.0 + auxdata->ae) / scales->length;
	bounds->phase[iphase]->state->upper[1] = 360.0 * d2r;
	bounds->phase[iphase]->state->upper[2] = 90.0 * d2r;
	bounds->phase[iphase]->state->upper[3] = 10000.0 / scales->speed;
	bounds->phase[iphase]->state->upper[4] = 10.0 * d2r;
	bounds->phase[iphase]->state->upper[5] = 300.0 * d2r;
	bounds->phase[iphase]->state->upper[6] = mass1 / scales->mass;
	bounds->phase[iphase]->state->upper[7] = INF;
	bounds->phase[iphase]->finalstate->lower[0] = (8.0 * 1000.0 + auxdata->be) / scales->length;
	bounds->phase[iphase]->finalstate->lower[1] = -360 * d2r;
	bounds->phase[iphase]->finalstate->lower[2] = -80 * d2r;
	bounds->phase[iphase]->finalstate->lower[3] = 100 / scales->speed;
	bounds->phase[iphase]->finalstate->lower[4] = -80 * d2r;
	bounds->phase[iphase]->finalstate->lower[5] = -300 * d2r;
	bounds->phase[iphase]->finalstate->lower[6] = mass2 / scales->mass;
	bounds->phase[iphase]->finalstate->lower[7] = -INF;
	bounds->phase[iphase]->finalstate->upper[0] = (200.0 * 1000.0 + auxdata->ae) / scales->length;
	bounds->phase[iphase]->finalstate->upper[1] = 360 * d2r;
	bounds->phase[iphase]->finalstate->upper[2] = 90 * d2r;
	bounds->phase[iphase]->finalstate->upper[3] = 10000 / scales->speed;
	bounds->phase[iphase]->finalstate->upper[4] = 10 * d2r;
	bounds->phase[iphase]->finalstate->upper[5] = 300 * d2r;
	bounds->phase[iphase]->finalstate->upper[6] = mass1 / scales->mass;
	bounds->phase[iphase]->finalstate->upper[7] = INF;
	bounds->phase[iphase]->control->lower[0] = -180 * d2r;
	bounds->phase[iphase]->control->lower[1] = -89 * d2r;
	bounds->phase[iphase]->control->upper[0] = 180 * d2r;
	bounds->phase[iphase]->control->upper[1] = 89 * d2r;
	bounds->phase[iphase]->parameter->lower[0] = -INF;
	bounds->phase[iphase]->parameter->lower[1] = -INF;
	bounds->phase[iphase]->parameter->upper[0] = INF;
	bounds->phase[iphase]->parameter->upper[1] = INF;
	bounds->phase[iphase]->path->nl->lower[0] = 8.0 * 1000.0 / scales->length;
	bounds->phase[iphase]->path->nl->lower[1] = 0.0;
	bounds->phase[iphase]->path->nl->lower[2] = 0.0;
	bounds->phase[iphase]->path->nl->upper[0] = 200.0 * 1000.0 / scales->length;
	bounds->phase[iphase]->path->nl->upper[1] = 0.0;
	bounds->phase[iphase]->path->nl->upper[2] = 0.0;
	bounds->phase[iphase]->endpoint->nl->lower[0] = 95.0 * 1000.0 / scales->length;
	bounds->phase[iphase]->endpoint->nl->lower[1] = 40.0 / scales->time;
	bounds->phase[iphase]->endpoint->nl->lower[2] = 0.0;
	bounds->phase[iphase]->endpoint->nl->lower[3] = 0.0;
	bounds->phase[iphase]->endpoint->nl->upper[0] = 95.0 * 1000.0 / scales->length;
	bounds->phase[iphase]->endpoint->nl->upper[1] = INF;
	bounds->phase[iphase]->endpoint->nl->upper[2] = 0.0;
	bounds->phase[iphase]->endpoint->nl->upper[3] = 0.0;
	floatVecFillin(bounds->phase[iphase]->linkage->nl->lower, numLinkNl, 0);
	floatVecFillin(bounds->phase[iphase]->linkage->nl->upper, numLinkNl, 0);


	// 4εĿռ
	iphase = 3;
	// 4εά
	numState = 8;
	numControl = 1;
	numParameter = 1;
	numPathNl = 3;
	numRowPathSoc = 0;
	numEndpNl = 4;
	numRowEndpSoc = 0;
	numLinkNl = 8;
	numRowLinkSoc = 0;
	mallocBoundPhase(bounds, iphase, numState, numControl, numParameter, numPathNl, numRowPathSoc, numEndpNl, numRowEndpSoc, numLinkNl, numRowLinkSoc, numPhase);
	// Լ߽縳ֵ
	bounds->phase[iphase]->initialtime->lower = auxdata->x0[7];
	bounds->phase[iphase]->initialtime->upper = auxdata->x0[7] + 3000.0 / scales->time;
	bounds->phase[iphase]->finaltime->lower = auxdata->x0[7];
	bounds->phase[iphase]->finaltime->upper = auxdata->x0[7] + 3000.0 / scales->time;
	bounds->phase[iphase]->initialstate->lower[0] = (8.0 * 1000.0 + auxdata->be) / scales->length;
	bounds->phase[iphase]->initialstate->lower[1] = -360.0 * d2r;
	bounds->phase[iphase]->initialstate->lower[2] = -80.0 * d2r;
	bounds->phase[iphase]->initialstate->lower[3] = 100.0 / scales->speed;
	bounds->phase[iphase]->initialstate->lower[4] = -80.0 * d2r;
	bounds->phase[iphase]->initialstate->lower[5] = -300.0 * d2r;
	bounds->phase[iphase]->initialstate->lower[6] = mass2 / scales->mass;
	bounds->phase[iphase]->initialstate->lower[7] = -INF;
	bounds->phase[iphase]->initialstate->upper[0] = (200.0 * 1000.0 + auxdata->ae) / scales->length;
	bounds->phase[iphase]->initialstate->upper[1] = 360.0 * d2r;
	bounds->phase[iphase]->initialstate->upper[2] = 90.0 * d2r;
	bounds->phase[iphase]->initialstate->upper[3] = 10000.0 / scales->speed;
	bounds->phase[iphase]->initialstate->upper[4] = 10.0 * d2r;
	bounds->phase[iphase]->initialstate->upper[5] = 300.0 * d2r;
	bounds->phase[iphase]->initialstate->upper[6] = mass2 / scales->mass;
	bounds->phase[iphase]->initialstate->upper[7] = INF;
	bounds->phase[iphase]->state->lower[0] = (8.0 * 1000.0 + auxdata->be) / scales->length;
	bounds->phase[iphase]->state->lower[1] = -360.0 * d2r;
	bounds->phase[iphase]->state->lower[2] = -80.0 * d2r;
	bounds->phase[iphase]->state->lower[3] = 100.0 / scales->speed;
	bounds->phase[iphase]->state->lower[4] = -80.0 * d2r;
	bounds->phase[iphase]->state->lower[5] = -300.0 * d2r;
	bounds->phase[iphase]->state->lower[6] = mass2 / scales->mass;
	bounds->phase[iphase]->state->lower[7] = -INF;
	bounds->phase[iphase]->state->upper[0] = (200.0 * 1000.0 + auxdata->ae) / scales->length;
	bounds->phase[iphase]->state->upper[1] = 360.0 * d2r;
	bounds->phase[iphase]->state->upper[2] = 90.0 * d2r;
	bounds->phase[iphase]->state->upper[3] = 10000.0 / scales->speed;
	bounds->phase[iphase]->state->upper[4] = 10.0 * d2r;
	bounds->phase[iphase]->state->upper[5] = 300.0 * d2r;
	bounds->phase[iphase]->state->upper[6] = mass2 / scales->mass;
	bounds->phase[iphase]->state->upper[7] = INF;
	bounds->phase[iphase]->finalstate->lower[0] = (8.0 * 1000.0 + auxdata->be) / scales->length;
	bounds->phase[iphase]->finalstate->lower[1] = -360 * d2r;
	bounds->phase[iphase]->finalstate->lower[2] = -80 * d2r;
	bounds->phase[iphase]->finalstate->lower[3] = 100 / scales->speed;
	bounds->phase[iphase]->finalstate->lower[4] = -80 * d2r;
	bounds->phase[iphase]->finalstate->lower[5] = -300 * d2r;
	bounds->phase[iphase]->finalstate->lower[6] = mass2 / scales->mass;
	bounds->phase[iphase]->finalstate->lower[7] = -INF;
	bounds->phase[iphase]->finalstate->upper[0] = (200.0 * 1000.0 + auxdata->ae) / scales->length;
	bounds->phase[iphase]->finalstate->upper[1] = 360 * d2r;
	bounds->phase[iphase]->finalstate->upper[2] = 90 * d2r;
	bounds->phase[iphase]->finalstate->upper[3] = 10000 / scales->speed;
	bounds->phase[iphase]->finalstate->upper[4] = 10 * d2r;
	bounds->phase[iphase]->finalstate->upper[5] = 300 * d2r;
	bounds->phase[iphase]->finalstate->upper[6] = mass2 / scales->mass;
	bounds->phase[iphase]->finalstate->upper[7] = INF;
	bounds->phase[iphase]->control->lower[0] = -90 * d2r;
	bounds->phase[iphase]->control->upper[0] = 90 * d2r;
	bounds->phase[iphase]->parameter->lower[0] = -INF;
	bounds->phase[iphase]->parameter->upper[0] = INF;
	bounds->phase[iphase]->path->nl->lower[0] = 8.0 * 1000.0 / scales->length;
	bounds->phase[iphase]->path->nl->lower[1] = -INF;
	bounds->phase[iphase]->path->nl->lower[2] = 0.0;
	bounds->phase[iphase]->path->nl->upper[0] = 200.0 * 1000.0 / scales->length;
	bounds->phase[iphase]->path->nl->upper[1] = 7.0;
	bounds->phase[iphase]->path->nl->upper[2] = 0.0;
	bounds->phase[iphase]->endpoint->nl->lower[0] = 30 * 1000 / scales->length;
	bounds->phase[iphase]->endpoint->nl->lower[1] = 10 / scales->time;
	bounds->phase[iphase]->endpoint->nl->lower[2] = 0.0;
	bounds->phase[iphase]->endpoint->nl->lower[3] = 0.0;
	bounds->phase[iphase]->endpoint->nl->upper[0] = INF;
	bounds->phase[iphase]->endpoint->nl->upper[1] = INF;
	bounds->phase[iphase]->endpoint->nl->upper[2] = 0.0;
	bounds->phase[iphase]->endpoint->nl->upper[3] = 0.0;
	floatVecFillin(bounds->phase[iphase]->linkage->nl->lower, numLinkNl, 0);
	floatVecFillin(bounds->phase[iphase]->linkage->nl->upper, numLinkNl, 0);


	// 5εĿռ
	iphase = 4;
	// 5εά
	numState = 8;
	numControl = 1;
	numParameter = 3;
	numPathNl = 3;
	numRowPathSoc = 0;
	numEndpNl = 4;
	numRowEndpSoc = 4;
	numLinkNl = 0;
	numRowLinkSoc = 0;
	mallocBoundPhase(bounds, iphase, numState, numControl, numParameter, numPathNl, numRowPathSoc, numEndpNl, numRowEndpSoc, numLinkNl, numRowLinkSoc, numPhase);
	// Լ߽縳ֵ
	bounds->phase[iphase]->initialtime->lower = auxdata->x0[7];
	bounds->phase[iphase]->initialtime->upper = auxdata->x0[7] + 3000.0 / scales->time;
	bounds->phase[iphase]->finaltime->lower = auxdata->x0[7];
	bounds->phase[iphase]->finaltime->upper = auxdata->x0[7] + 3000.0 / scales->time;
	bounds->phase[iphase]->initialstate->lower[0] = (7.0 * 1000.0 + auxdata->be) / scales->length;
	bounds->phase[iphase]->initialstate->lower[1] = -360.0 * d2r;
	bounds->phase[iphase]->initialstate->lower[2] = -80.0 * d2r;
	bounds->phase[iphase]->initialstate->lower[3] = 100.0 / scales->speed;
	bounds->phase[iphase]->initialstate->lower[4] = -80.0 * d2r;
	bounds->phase[iphase]->initialstate->lower[5] = -300.0 * d2r;
	bounds->phase[iphase]->initialstate->lower[6] = mass2 / scales->mass;
	bounds->phase[iphase]->initialstate->lower[7] = -INF;
	bounds->phase[iphase]->initialstate->upper[0] = (200.0 * 1000.0 + auxdata->ae) / scales->length;
	bounds->phase[iphase]->initialstate->upper[1] = 360.0 * d2r;
	bounds->phase[iphase]->initialstate->upper[2] = 90.0 * d2r;
	bounds->phase[iphase]->initialstate->upper[3] = 10000.0 / scales->speed;
	bounds->phase[iphase]->initialstate->upper[4] = 10.0 * d2r;
	bounds->phase[iphase]->initialstate->upper[5] = 300.0 * d2r;
	bounds->phase[iphase]->initialstate->upper[6] = mass2 / scales->mass;
	bounds->phase[iphase]->initialstate->upper[7] = INF;
	bounds->phase[iphase]->state->lower[0] = (7.0 * 1000.0 + auxdata->be) / scales->length;
	bounds->phase[iphase]->state->lower[1] = -360.0 * d2r;
	bounds->phase[iphase]->state->lower[2] = -80.0 * d2r;
	bounds->phase[iphase]->state->lower[3] = 100.0 / scales->speed;
	bounds->phase[iphase]->state->lower[4] = -80.0 * d2r;
	bounds->phase[iphase]->state->lower[5] = -300.0 * d2r;
	bounds->phase[iphase]->state->lower[6] = mass2 / scales->mass;
	bounds->phase[iphase]->state->lower[7] = -INF;
	bounds->phase[iphase]->state->upper[0] = (200.0 * 1000.0 + auxdata->ae) / scales->length;
	bounds->phase[iphase]->state->upper[1] = 360.0 * d2r;
	bounds->phase[iphase]->state->upper[2] = 90.0 * d2r;
	bounds->phase[iphase]->state->upper[3] = 10000.0 / scales->speed;
	bounds->phase[iphase]->state->upper[4] = 10.0 * d2r;
	bounds->phase[iphase]->state->upper[5] = 300.0 * d2r;
	bounds->phase[iphase]->state->upper[6] = mass2 / scales->mass;
	bounds->phase[iphase]->state->upper[7] = INF;
	bounds->phase[iphase]->finalstate->lower[0] = (7.0 * 1000.0 + auxdata->be) / scales->length;
	bounds->phase[iphase]->finalstate->lower[1] = -360 * d2r;
	bounds->phase[iphase]->finalstate->lower[2] = -80 * d2r;
	bounds->phase[iphase]->finalstate->lower[3] = 100 / scales->speed;
	bounds->phase[iphase]->finalstate->lower[4] = -80 * d2r;
	bounds->phase[iphase]->finalstate->lower[5] = -300 * d2r;
	bounds->phase[iphase]->finalstate->lower[6] = mass2 / scales->mass;
	bounds->phase[iphase]->finalstate->lower[7] = -INF;
	bounds->phase[iphase]->finalstate->upper[0] = (200.0 * 1000.0 + auxdata->ae) / scales->length;
	bounds->phase[iphase]->finalstate->upper[1] = 360 * d2r;
	bounds->phase[iphase]->finalstate->upper[2] = 90 * d2r;
	bounds->phase[iphase]->finalstate->upper[3] = 300 / scales->speed;
	bounds->phase[iphase]->finalstate->upper[4] = 10 * d2r;
	bounds->phase[iphase]->finalstate->upper[5] = 300 * d2r;
	bounds->phase[iphase]->finalstate->upper[6] = mass2 / scales->mass;
	bounds->phase[iphase]->finalstate->upper[7] = INF;
	bounds->phase[iphase]->control->lower[0] = -90 * d2r;
	bounds->phase[iphase]->control->upper[0] = 90 * d2r;
	bounds->phase[iphase]->parameter->lower[0] = -INF;
	bounds->phase[iphase]->parameter->lower[1] = -INF;
	bounds->phase[iphase]->parameter->lower[2] = -INF;
	bounds->phase[iphase]->parameter->upper[0] = INF;
	bounds->phase[iphase]->parameter->upper[1] = INF;
	bounds->phase[iphase]->parameter->upper[2] = INF;
	bounds->phase[iphase]->path->nl->lower[0] = 8.0 * 1000.0 / scales->length;
	bounds->phase[iphase]->path->nl->lower[1] = -INF;
	bounds->phase[iphase]->path->nl->lower[2] = 0.0;
	bounds->phase[iphase]->path->nl->upper[0] = 200.0 * 1000.0 / scales->length;
	bounds->phase[iphase]->path->nl->upper[1] = 7.0;
	bounds->phase[iphase]->path->nl->upper[2] = 0.0;
	bounds->phase[iphase]->endpoint->nl->lower[0] = 8.0 * 1000.0 / scales->length;
	bounds->phase[iphase]->endpoint->nl->lower[1] = 10 / scales->time;
	bounds->phase[iphase]->endpoint->nl->lower[2] = 0.0;
	bounds->phase[iphase]->endpoint->nl->lower[3] = 0.0;
	bounds->phase[iphase]->endpoint->nl->upper[0] = 8.0 * 1000.0 / scales->length;
	bounds->phase[iphase]->endpoint->nl->upper[1] = INF;
	bounds->phase[iphase]->endpoint->nl->upper[2] = 0.0;
	bounds->phase[iphase]->endpoint->nl->upper[3] = 0.0;
	bounds->phase[iphase]->endpoint->soc[0] = 0.0;
	bounds->phase[iphase]->endpoint->soc[1] = downRange * 1000 / scales->length;
	bounds->phase[iphase]->endpoint->soc[2] = 0;
	bounds->phase[iphase]->endpoint->soc[3] = crossRange * 1000 / scales->length;

	// άϢռ
	// ռ
	dimension = (cmscp_dimension*)malloc(sizeof(cmscp_dimension));
	mallocDimension(dimension, numPhase, 0);
	// 1εĿռ
	iphase = 0;
	mallocDimensionPhase(dimension, iphase, 0, 0, 0, numPhase);
	// õ1εά
	dimension->phase[iphase]->state = 8;
	dimension->phase[iphase]->control = 2;
	dimension->phase[iphase]->parameter = 2;
	dimension->phase[iphase]->path->nl = 3;
	dimension->phase[iphase]->path->soc->n = 0;
	dimension->phase[iphase]->endpoint->nl = 3;
	dimension->phase[iphase]->endpoint->soc->n = 0;
	dimension->phase[iphase]->linkage->nl = 8;
	dimension->phase[iphase]->linkage->soc->n = 0;
	// 2εĿռ
	iphase = 1;
	mallocDimensionPhase(dimension, iphase, 0, 1, 0, numPhase);
	// õ2εά
	dimension->phase[iphase]->state = 8;
	dimension->phase[iphase]->control = 2;
	dimension->phase[iphase]->parameter = 2;
	dimension->phase[iphase]->path->nl = 3;
	dimension->phase[iphase]->path->soc->n = 0;
	dimension->phase[iphase]->endpoint->nl = 3;
	dimension->phase[iphase]->endpoint->soc->n = 1;
	dimension->phase[iphase]->endpoint->soc->q[0] = 2;
	dimension->phase[iphase]->linkage->nl = 8;
	dimension->phase[iphase]->linkage->soc->n = 0;

	// 3εĿռ
	iphase = 2;
	mallocDimensionPhase(dimension, iphase, 0, 0, 0, numPhase);
	// õ3εά
	dimension->phase[iphase]->state = 8;
	dimension->phase[iphase]->control = 2;
	dimension->phase[iphase]->parameter = 2;
	dimension->phase[iphase]->path->nl = 3;
	dimension->phase[iphase]->path->soc->n = 0;
	dimension->phase[iphase]->endpoint->nl = 4;
	dimension->phase[iphase]->endpoint->soc->n = 0;
	dimension->phase[iphase]->linkage->nl = 7;
	dimension->phase[iphase]->linkage->soc->n = 0;

	// 4εĿռ
	iphase = 3;
	mallocDimensionPhase(dimension, iphase, 0, 0, 0, numPhase);
	// õ4εά
	dimension->phase[iphase]->state = 8;
	dimension->phase[iphase]->control = 1;
	dimension->phase[iphase]->parameter = 1;
	dimension->phase[iphase]->path->nl = 3;
	dimension->phase[iphase]->path->soc->n = 0;
	dimension->phase[iphase]->endpoint->nl = 4;
	dimension->phase[iphase]->endpoint->soc->n = 0;
	dimension->phase[iphase]->linkage->nl = 8;
	dimension->phase[iphase]->linkage->soc->n = 0;

	// 5εĿռ
	iphase = 4;
	mallocDimensionPhase(dimension, iphase, 0, 2, 0, numPhase);
	// õ5εά
	dimension->phase[iphase]->state = 8;
	dimension->phase[iphase]->control = 1;
	dimension->phase[iphase]->parameter = 3;
	dimension->phase[iphase]->path->nl = 3;
	dimension->phase[iphase]->path->soc->n = 0;
	dimension->phase[iphase]->endpoint->nl = 4;
	dimension->phase[iphase]->endpoint->soc->n = 2;
	dimension->phase[iphase]->endpoint->soc->q[0] = 2;
	dimension->phase[iphase]->endpoint->soc->q[1] = 2;

	// ¼ԼάϢ
	dimension->event->nl = 0;
	dimension->event->soc->n = 0;


	// Ϣռ
	trust = (cmscp_trust*)malloc(sizeof(cmscp_trust));
	mallocTrust(trust, numPhase);
	trust->model = "hard";
	// 1εĿռ
	iphase = 0;
	mallocTrustPhase(trust, iphase, dimension->phase[iphase]->state, dimension->phase[iphase]->control, dimension->phase[iphase]->parameter);
	// õ1εά
	trust->phase[iphase]->hardRadius = 0.5;
	trust->phase[iphase]->softPenaWeight = 1E3;
	trust->phase[iphase]->weight->initialtime = 2.0;
	trust->phase[iphase]->weight->finaltime = 2.0;
	floatVecFillin(trust->phase[iphase]->weight->state, dimension->phase[iphase]->state, 1);
	floatVecFillin(trust->phase[iphase]->weight->control, dimension->phase[iphase]->control, 1);
	floatVecFillin(trust->phase[iphase]->weight->parameter, dimension->phase[iphase]->parameter, 0);

	// 2εĿռ
	iphase = 1;
	mallocTrustPhase(trust, iphase, dimension->phase[iphase]->state, dimension->phase[iphase]->control, dimension->phase[iphase]->parameter);
	// õ2εά
	trust->phase[iphase]->hardRadius = 0.5;
	trust->phase[iphase]->softPenaWeight = 1E3;
	trust->phase[iphase]->weight->initialtime = 2.0;
	trust->phase[iphase]->weight->finaltime = 2.0;
	floatVecFillin(trust->phase[iphase]->weight->state, dimension->phase[iphase]->state, 2.0);
	floatVecFillin(trust->phase[iphase]->weight->control, dimension->phase[iphase]->control, 1);
	floatVecFillin(trust->phase[iphase]->weight->parameter, dimension->phase[iphase]->parameter, 0);

	// 3εĿռ
	iphase = 2;
	mallocTrustPhase(trust, iphase, dimension->phase[iphase]->state, dimension->phase[iphase]->control, dimension->phase[iphase]->parameter);
	// õ3εά
	trust->phase[iphase]->hardRadius = 0.5;
	trust->phase[iphase]->softPenaWeight = 1E3;
	trust->phase[iphase]->weight->initialtime = 2.0;
	trust->phase[iphase]->weight->finaltime = 2.0;
	floatVecFillin(trust->phase[iphase]->weight->state, dimension->phase[iphase]->state, 1);
	floatVecFillin(trust->phase[iphase]->weight->control, dimension->phase[iphase]->control, 1);
	floatVecFillin(trust->phase[iphase]->weight->parameter, dimension->phase[iphase]->parameter, 0);
	// 4εĿռ
	iphase = 3;
	mallocTrustPhase(trust, iphase, dimension->phase[iphase]->state, dimension->phase[iphase]->control, dimension->phase[iphase]->parameter);
	// õ4εά
	trust->phase[iphase]->hardRadius = 0.5;
	trust->phase[iphase]->softPenaWeight = 1E3;
	trust->phase[iphase]->weight->initialtime = 2.0;
	trust->phase[iphase]->weight->finaltime = 2.0;
	floatVecFillin(trust->phase[iphase]->weight->state, dimension->phase[iphase]->state, 2.0);
	floatVecFillin(trust->phase[iphase]->weight->control, dimension->phase[iphase]->control, 1.0);
	floatVecFillin(trust->phase[iphase]->weight->parameter, dimension->phase[iphase]->parameter, 0.0);

	// 5εĿռ
	iphase = 4;
	mallocTrustPhase(trust, iphase, dimension->phase[iphase]->state, dimension->phase[iphase]->control, dimension->phase[iphase]->parameter);
	// õ5εά
	trust->phase[iphase]->hardRadius = 0.5;
	trust->phase[iphase]->softPenaWeight = 1E3;
	trust->phase[iphase]->weight->initialtime = 2.0;
	trust->phase[iphase]->weight->finaltime = 2.0;
	floatVecFillin(trust->phase[iphase]->weight->state, dimension->phase[iphase]->state, 2.0);
	floatVecFillin(trust->phase[iphase]->weight->control, dimension->phase[iphase]->control, 1.0);
	floatVecFillin(trust->phase[iphase]->weight->parameter, dimension->phase[iphase]->parameter, 0.0);

	// ṩϢ
	functions = (cmscp_functions*)malloc(sizeof(cmscp_functions));
	mallocFunctions(functions, numPhase);
	// 1εĿռ
	iphase = 0;
	mallocFunctionsPhase(functions, iphase);
	// õ1κ
	functions->phase[iphase]->continuous = dynProg2;
	functions->phase[iphase]->endpoint = endpoint1;
	functions->phase[iphase]->linkage = linkage1;
	// 2εĿռ
	iphase = 1;
	mallocFunctionsPhase(functions, iphase);
	// õ2κ
	functions->phase[iphase]->continuous = dynProg1;
	functions->phase[iphase]->endpoint = endpoint2;
	functions->phase[iphase]->linkage = linkage1;
	// 3εĿռ
	iphase = 2;
	mallocFunctionsPhase(functions, iphase);
	// õ3κ
	functions->phase[iphase]->continuous = dynProg2;
	functions->phase[iphase]->endpoint = endpoint3;
	functions->phase[iphase]->linkage = linkage2;
	// 4εĿռ
	iphase = 3;
	mallocFunctionsPhase(functions, iphase);
	// õ4κ
	functions->phase[iphase]->continuous = dynProg3;
	functions->phase[iphase]->endpoint = endpoint4;
	functions->phase[iphase]->linkage = linkage1;
	// 5εĿռ
	iphase = 4;
	mallocFunctionsPhase(functions, iphase);
	// õ5κ
	functions->phase[iphase]->continuous = dynProg3;
	functions->phase[iphase]->endpoint = endpoint5;

	// Ŀ꺯ʱ亯
	functions->objEvent = objEvent;

	// Ŀ꺯ʱ亯
	functions->objEventDepend = getObjEventDepend;
	functions->contDepend = getContDepend;
	functions->endpDepend = getEndpDepend;
	functions->linkDepend = getLinkDepend;

	// Ի躯
	functions->getIniRefTraj = getIniRefTraj;
	functions->stopCondition = stopCondition;
	functions->updateMeshInfo = updateMeshInfo;
	functions->updateTrustInfo = updateTrustInfo;
	functions->updateRefTraj = updateRefTraj;

	// ÿɢϢ
	mesh = (cmscp_mesh**)malloc(numPhase * sizeof(cmscp_mesh*));
	iphase = 0;
	mesh[iphase] = (cmscp_mesh*)malloc(sizeof(cmscp_mesh));
	mesh[iphase]->num = 20;
	mesh[iphase]->node = (double*)malloc(mesh[iphase]->num * sizeof(double));
	linSpace(0, 1, mesh[iphase]->num, mesh[iphase]->node);
	iphase = 1;
	mesh[iphase] = (cmscp_mesh*)malloc(sizeof(cmscp_mesh));
	mesh[iphase]->num = 20;
	mesh[iphase]->node = (double*)malloc(mesh[iphase]->num * sizeof(double));
	linSpace(0, 1, mesh[iphase]->num, mesh[iphase]->node);
	iphase = 2;
	mesh[iphase] = (cmscp_mesh*)malloc(sizeof(cmscp_mesh));
	mesh[iphase]->num = 30;
	mesh[iphase]->node = (double*)malloc(mesh[iphase]->num * sizeof(double));
	linSpace(0, 1, mesh[iphase]->num, mesh[iphase]->node);
	iphase = 3;
	mesh[iphase] = (cmscp_mesh*)malloc(sizeof(cmscp_mesh));
	mesh[iphase]->num = 30;
	mesh[iphase]->node = (double*)malloc(mesh[iphase]->num * sizeof(double));
	linSpace(0, 1, mesh[iphase]->num, mesh[iphase]->node);
	iphase = 4;
	mesh[iphase] = (cmscp_mesh*)malloc(sizeof(cmscp_mesh));
	mesh[iphase]->num = 30;
	mesh[iphase]->node = (double*)malloc(mesh[iphase]->num * sizeof(double));
	linSpace(0, 1, mesh[iphase]->num, mesh[iphase]->node);

	// ͹Ż㷨Ϣ
	scpInfo = (cmscp_scp*)malloc(sizeof(cmscp_scp));
	scpInfo->solver = (cmscp_solverInfo*)malloc(sizeof(cmscp_solverInfo));
#ifdef LUOYC
	scpInfo->maxIter = 1;
#else
	scpInfo->maxIter = 50;
#endif
	scpInfo->obj = (double*)malloc(scpInfo->maxIter*sizeof(double));
#ifdef USE_CSOCP
	scpInfo->solver->name = "csocp";
#else
	scpInfo->solver->name = "ecos";
#endif
	scpInfo->solver->maxit = 100;
	scpInfo->solver->abstol = 1e-1;
	scpInfo->solver->reltol = 1e-1;
	scpInfo->solver->feastol = 1e-05;
	scpInfo->solver->verbose = 1;

	// Ϣϵһṹsetup
	setup = (cmscp_setup*)malloc(sizeof(cmscp_setup));
	setup->numPhase = numPhase;
	setup->derStep = 1E-6;
	setup->sparseModel = "manuSparse";
	setup->functions = functions;
	setup->auxdata = auxdata;
	setup->bounds = bounds;
	setup->dimension = dimension;
	setup->mesh = mesh;
	setup->trust = trust;
	setup->scpInfo = scpInfo;


	// ʹCMSCP켣滮
	optTraj = (cmscp_trajInfo**)malloc(setup->numPhase * sizeof(cmscp_trajInfo*));
	tic(&timer);
	int exitFlag = cmscp(optTraj, setup);
	time = toc(&timer);

	// ͷſռ䣨ECOSһڴ޷ͷţ
	// ͷŹ켣ռ
	freeTrajInfo(optTraj, setup, 1);
	// ͷŸռ
	free(auxdata->scales);
	free(auxdata);
	// ͷsetupռ
	freeSetup(&setup);

#ifndef LUOYC20220727   // use register to compute time
	end_time = _itoll(TSCH, TSCL);
	printf("end_time: %d \n", end_time);
	use_time = end_time - start_time - cycle_over_time;
 	printf("use_time = %d\n", use_time);
 	double ff = 1000000000;
 	printf("duration:%lf s\n",( (double) use_time / ff ));

#endif
	// 
	return 1;
}
