#include "gradInfoFunctions.h"

void copyObjEventInput(cmscp_objEventInput*x, cmscp_objEventInput* y, cmscp_setup* setup)
{
	// ܣcopyObjEventInputα
	// 룺
	// xԭ
	// setupò
	// 
	// y
	// лڣ2022 / 6 / 28д
	int iphase, numPhase, numState, numParameter;
	cmscp_dimension* dimension;

	numPhase = setup->numPhase;	// ׶
	dimension = setup->dimension;
	for ( iphase = 0; iphase < numPhase; iphase++)
	{
		numState = dimension->phase[iphase]->state;
		numParameter = dimension->phase[iphase]->parameter;
		y->phase[iphase]->initialtime = x->phase[iphase]->initialtime;
		y->phase[iphase]->finaltime = x->phase[iphase]->finaltime;
		copyFloatVec(x->phase[iphase]->initialstate, y->phase[iphase]->initialstate, numState, 0);
		copyFloatVec(x->phase[iphase]->finalstate, y->phase[iphase]->finalstate, numState, 0);
		copyFloatVec(x->phase[iphase]->parameter, y->phase[iphase]->parameter, numParameter, 0);
	}

}

void copyEndpInput(cmscp_endpInput* x, cmscp_endpInput* y, int iphase, cmscp_setup* setup)
{
	// ܣcmscp_endpInputα
	// 룺
	// xԭ
	// setupò
	// 
	// y
	// лڣ2022 / 6 / 28д
	int numPhase;
	cmscp_dimension* dimension;

	numPhase = setup->numPhase;	// ׶
	dimension = setup->dimension;
	copyFloatVec(x->initialstate, y->initialstate, dimension->phase[iphase]->state, 0);
	copyFloatVec(x->finalstate, y->finalstate, dimension->phase[iphase]->state, 0);
	copyFloatVec(x->parameter, y->parameter, dimension->phase[iphase]->parameter, 0);
	y->initialtime = x->initialtime;
	y->finaltime = x->finaltime;
}

void copyContInput(cmscp_contInput* x, cmscp_contInput* y, int numState, int numControl, int numParameter, cmscp_setup* setup)
{
	// ܣcmscp_endpInputα
	// 룺
	// xԭ
	// setupò
	// 
	// y
	// лڣ2022 / 6 / 28д
	cmscp_dimension* dimension;
	dimension = setup->dimension;
	copyFloatVec(x->state, y->state, numState, 0);
	copyFloatVec(x->control, y->control, numControl, 0);
	copyFloatVec(x->parameter, y->parameter, numParameter, 0);
}

void copyLinkInput(cmscp_linkInput* x, cmscp_linkInput* y, int iphase, cmscp_setup* setup)
{
	// ܣcmscp_endpInputα
	// 룺
	// xԭ
	// setupò
	// 
	// y
	// лڣ2022 / 6 / 28д
	cmscp_dimension* dimension;
	dimension = setup->dimension;
	y->leftFinTime = x->leftFinTime;
	y->rightIniTime = x->rightIniTime;
	copyFloatVec(x->leftFinState, y->leftFinState, dimension->phase[iphase]->state, 0);
	copyFloatVec(x->leftParameter, y->leftParameter, dimension->phase[iphase]->parameter, 0);
	copyFloatVec(x->rightIniState, y->rightIniState, dimension->phase[iphase+1]->state, 0);
	copyFloatVec(x->rightParameter, y->rightParameter, dimension->phase[iphase+1]->parameter, 0);
}
void gradInfoSparseObjEvent(cmscp_derInfo** objDerInfo0, cmscp_derInfo** eventDerInfo0, cmscp_sparseInfo* sparseInfo, cmscp_trajInfo** refTraj, cmscp_setup* setup)
{
	// ܣȡ׶滮ĲάԼӦĿռ
	// 룺
	// refTrajο켣
	// sparseInfoϡ裨ԪλãϢ
	// setupò
	// 
	// objDerInfoĿ꺯һ׵Ϣ
	// eventDerInfo¼һ׵Ϣ
	// Triʾ߽
	// лڣ2022 / 6 / 27д

	// 
	int numPhase, numObjEventInput, numEventOutput, iphase, numState, numControl, numParameter, numMesh, cntObjEventInput, *iniStateNzIdxRow, * finStateNzIdxRow, * iniTimeNzIdxRow, * finTimeNzIdxRow, * parameterNzIdxRow, *iniStateNzPtrCol, * finStateNzPtrCol, * iniTimeNzPtrCol, * finTimeNzPtrCol, * parameterNzPtrCol, j, p, i, idxRowEventGrd;
	double derStep, derStepInv, refObjOutput, pertObjOutput, *refEventOutput, *pertEventOutput, *objGrd, * eventGrd;
	cmscp_dimension* dimension;
	cmscp_mesh** mesh;
	cmscp_nzPos_endp** objEventNzPos;
	cmscp_objEventInput* objEventInput, *pertObjEventInput;
	cmscp_objEvent objEventFunc;

	//  1. 
	dimension = setup->dimension;	// άϢ
	mesh = setup->mesh;	// Ϣ
	numPhase = setup->numPhase;	// ׶
	derStep = setup->derStep; // 󵼲
	derStepInv = 1 / derStep;
	objEventFunc = setup->functions->objEvent;
	numObjEventInput = 0; // ˵㺯
	objEventNzPos = sparseInfo->objEventNzPos; // ϡϢ

	// ¼ά
	if (dimension->event->soc->n)
	{
		numEventOutput = dimension->event->nl + cmscp_sum(dimension->event->soc->q, dimension->event->soc->n);
	}
	else
	{
		numEventOutput = dimension->event->nl;
	}
	// 
	objEventInput = (cmscp_objEventInput*)malloc(sizeof(cmscp_objEventInput));
	objEventInput->phase = (cmscp_objEventInputPhase**)malloc(setup->numPhase * sizeof(cmscp_objEventInputPhase*));
	objEventInput->auxdata = setup->auxdata;
	for ( iphase = 0; iphase < numPhase; iphase++)
	{
		numMesh = mesh[iphase]->num;
		numState = dimension->phase[iphase]->state;
		numControl = dimension->phase[iphase]->control;
		numParameter = dimension->phase[iphase]->parameter;
		objEventInput->phase[iphase]  = (cmscp_objEventInputPhase*)malloc(sizeof(cmscp_objEventInputPhase));
		objEventInput->phase[iphase]->initialtime = refTraj[iphase]->initialtime;
		objEventInput->phase[iphase]->finaltime = refTraj[iphase]->finaltime;
		objEventInput->phase[iphase]->initialstate = refTraj[iphase]->state->v;
		objEventInput->phase[iphase]->finalstate = refTraj[iphase]->state->v + (numMesh - 1) * numState;
		objEventInput->phase[iphase]->parameter = refTraj[iphase]->parameter;

		numObjEventInput = numObjEventInput + 2 * dimension->phase[iphase]->state + 2 + dimension->phase[iphase]->parameter;
	}
	cntObjEventInput = 0; // ˵㺯
	refEventOutput = (double*)malloc(numEventOutput * sizeof(double));
	objEventFunc(&refObjOutput, refEventOutput, objEventInput); // οֵ

	objGrd = (double*)malloc(numObjEventInput * sizeof(double)); // Ŀ꺯ݶȿռ
	eventGrd = (double*)malloc(numEventOutput * numObjEventInput * sizeof(double));
	//if (numEventOutput)
	//{
	//	eventGrd = (double*)malloc(numEventOutput * numObjEventInput * sizeof(double));
	//}

	// Ŷռ
	pertEventOutput = (double*)malloc(numEventOutput * sizeof(double));
	pertObjEventInput = (cmscp_objEventInput*)malloc(sizeof(cmscp_objEventInput));
	pertObjEventInput->phase = (cmscp_objEventInputPhase**)malloc(setup->numPhase * sizeof(cmscp_objEventInputPhase*));
	for ( iphase = 0; iphase < numPhase; iphase++)
	{
		pertObjEventInput->phase[iphase] = (cmscp_objEventInputPhase*)malloc(sizeof(cmscp_objEventInputPhase));
		pertObjEventInput->phase[iphase]->initialstate = (double*)malloc(numState * sizeof(double));
		pertObjEventInput->phase[iphase]->finalstate = (double*)malloc(numState * sizeof(double));
		pertObjEventInput->phase[iphase]->parameter = (double*)malloc(numParameter * sizeof(double));
	}

	for (iphase = 0; iphase < numPhase; iphase++)
	{
		// ɢ͸ֱά
		numState = dimension->phase[iphase]->state;
		numParameter = dimension->phase[iphase]->parameter;
		// ϡϢ

		iniStateNzIdxRow = objEventNzPos[iphase]->iniState->idxRow;
		finStateNzIdxRow = objEventNzPos[iphase]->finState->idxRow;
		iniTimeNzIdxRow = objEventNzPos[iphase]->iniTime->idxRow;
		finTimeNzIdxRow = objEventNzPos[iphase]->finTime->idxRow;
		parameterNzIdxRow = objEventNzPos[iphase]->parameter->idxRow;
		iniStateNzPtrCol = objEventNzPos[iphase]->iniState->ptrCol;
		finStateNzPtrCol = objEventNzPos[iphase]->finState->ptrCol;
		iniTimeNzPtrCol = objEventNzPos[iphase]->iniTime->ptrCol;
		finTimeNzPtrCol = objEventNzPos[iphase]->finTime->ptrCol;
		parameterNzPtrCol = objEventNzPos[iphase]->parameter->ptrCol;

		pertObjEventInput->auxdata = setup->auxdata;
		numMesh = mesh[iphase]->num;
		numState = dimension->phase[iphase]->state;
		numControl = dimension->phase[iphase]->control;
		numParameter = dimension->phase[iphase]->parameter;

		// ʼ״̬
		for (j = 0; j < numState; j++)
		{
			// Ŷ
			copyObjEventInput(objEventInput, pertObjEventInput, setup);
			pertObjEventInput->phase[iphase]->initialstate[j] = pertObjEventInput->phase[iphase]->initialstate[j] + derStep;
			// ʩŶ
			objEventFunc(&pertObjOutput, pertEventOutput, pertObjEventInput);// Ŷ
			for (p = iniStateNzPtrCol[j]; p < iniStateNzPtrCol[j + 1]; p++)
			{
				i = iniStateNzIdxRow[p]; //
				if (i == 0)
				{
					objGrd[cntObjEventInput] = (pertObjOutput - refObjOutput) * derStepInv;
				}
				else
				{
					idxRowEventGrd = (i - 1);
					eventGrd[idxRowEventGrd + numEventOutput * cntObjEventInput] = (pertEventOutput[idxRowEventGrd] - refEventOutput[idxRowEventGrd]) * derStepInv;
				}
			}
			cntObjEventInput++;
		}


		// ն״̬
		for (j = 0; j < numState; j++)
		{
			// Ŷ
			copyObjEventInput(objEventInput, pertObjEventInput, setup);
			pertObjEventInput->phase[iphase]->finalstate[j] = pertObjEventInput->phase[iphase]->finalstate[j] + derStep;
			// ʩŶ
			objEventFunc(&pertObjOutput, pertEventOutput, pertObjEventInput);// Ŷ
			for (p = finStateNzPtrCol[j]; p < finStateNzPtrCol[j + 1]; p++)
			{
				i = finStateNzIdxRow[p]; //
				if (i == 0)
				{
					objGrd[cntObjEventInput] = (pertObjOutput - refObjOutput) * derStepInv;
				}
				else
				{
					idxRowEventGrd = (i - 1);
					eventGrd[idxRowEventGrd + numEventOutput * cntObjEventInput] = (pertEventOutput[idxRowEventGrd] - refEventOutput[idxRowEventGrd]) * derStepInv;
				}
			}
			cntObjEventInput++;
		}

		// ʼʱ
		// Ŷ
		copyObjEventInput(objEventInput, pertObjEventInput, setup);
		pertObjEventInput->phase[iphase]->initialtime = pertObjEventInput->phase[iphase]->initialtime + derStep;
		// ʩŶ
		objEventFunc(&pertObjOutput, pertEventOutput, pertObjEventInput);// Ŷ
		for (p = iniTimeNzPtrCol[0]; p < iniTimeNzPtrCol[1]; p++)
		{
			i = iniTimeNzIdxRow[p]; //
			if (i == 0)
			{
				objGrd[cntObjEventInput] = (pertObjOutput - refObjOutput) * derStepInv;
			}
			else
			{
				idxRowEventGrd = (i - 1);
				eventGrd[idxRowEventGrd + numEventOutput * cntObjEventInput] = (pertEventOutput[idxRowEventGrd] - refEventOutput[idxRowEventGrd]) * derStepInv;
			}
		}
		cntObjEventInput++;
		// նʱ
		// Ŷ
		copyObjEventInput(objEventInput, pertObjEventInput, setup);
		pertObjEventInput->phase[iphase]->finaltime = pertObjEventInput->phase[iphase]->finaltime + derStep;
		// ʩŶ
		objEventFunc(&pertObjOutput, pertEventOutput, pertObjEventInput);// Ŷ
		for (p = finTimeNzPtrCol[0]; p < finTimeNzPtrCol[1]; p++)
		{
			i = finTimeNzIdxRow[p]; //
			if (i == 0)
			{
				objGrd[cntObjEventInput] = (pertObjOutput - refObjOutput) * derStepInv;
			}
			else
			{
				idxRowEventGrd = (i - 1);
				eventGrd[idxRowEventGrd + numEventOutput * cntObjEventInput] = (pertEventOutput[idxRowEventGrd] - refEventOutput[idxRowEventGrd]) * derStepInv;
			}
		}
		cntObjEventInput++;

		// ն״̬
		for (j = 0; j < numParameter; j++)
		{
			// Ŷ
			copyObjEventInput(objEventInput, pertObjEventInput, setup);
			pertObjEventInput->phase[iphase]->parameter[j] = pertObjEventInput->phase[iphase]->parameter[j] + derStep;
			// ʩŶ
			objEventFunc(&pertObjOutput, pertEventOutput, pertObjEventInput);// Ŷ
			for (p = parameterNzPtrCol[j]; p < parameterNzPtrCol[j + 1]; p++)
			{
				i = parameterNzIdxRow[p]; //
				if (i == 0)
				{
					objGrd[cntObjEventInput] = (pertObjOutput - refObjOutput) * derStepInv;
				}
				else
				{
					idxRowEventGrd = (i - 1);
					eventGrd[idxRowEventGrd + numEventOutput * cntObjEventInput] = (pertEventOutput[idxRowEventGrd] - refEventOutput[idxRowEventGrd]) * derStepInv;
				}
			}
			cntObjEventInput++;
		}
	}
	// 
	// ڴ
	(*objDerInfo0) = (cmscp_derInfo*)malloc(sizeof(cmscp_derInfo));
	(*objDerInfo0)->ref = (double*)malloc(sizeof(double));
	(*objDerInfo0)->ref[0] = refObjOutput;
	(*objDerInfo0)->der = objGrd;
	(*eventDerInfo0) = (cmscp_derInfo*)malloc(sizeof(cmscp_derInfo));
	(*eventDerInfo0)->ref = refEventOutput;
	(*eventDerInfo0)->der = eventGrd;

	// free 
	free(pertEventOutput);
	for (iphase = 0; iphase < numPhase; iphase++)
	{
		free(pertObjEventInput->phase[iphase]->initialstate);
		free(pertObjEventInput->phase[iphase]->finalstate);
		free(pertObjEventInput->phase[iphase]->parameter);
		free(pertObjEventInput->phase[iphase]);
		free(objEventInput->phase[iphase]);
	}
	free(pertObjEventInput->phase);
	free(pertObjEventInput);
	free(objEventInput->phase);
	free(objEventInput);
	
}
void gradInfoSparseEndp(cmscp_derInfo** gradInfo, cmscp_sparseInfo* sparseInfo, cmscp_trajInfo** refTraj, cmscp_setup* setup) {
	// 
	int numPhase, iphase, numState, numParameter, * iniStateNzIdxRow, * finStateNzIdxRow, * iniTimeNzIdxRow, * finTimeNzIdxRow, * parameterNzIdxRow, * iniStateNzPtrCol, * finStateNzPtrCol, * iniTimeNzPtrCol, * finTimeNzPtrCol, * parameterNzPtrCol, j, p, i, numEndpInput, numEndpOutput, cntCol;
	double derStep, derStepInv, *refOutput, *pertOutput, * endpGrd;
	cmscp_dimension* dimension;
	cmscp_mesh** mesh;
	cmscp_nzPos_endp** endpNzPos;
	cmscp_endpInput* endpInput, * pertEndpInput;
	cmscp_endpoint endpFunc;

	//  1. 
	dimension = setup->dimension;	// άϢ
	mesh = setup->mesh;	// Ϣ
	numPhase = setup->numPhase;	// ׶
	derStep = setup->derStep; // 󵼲
	derStepInv = 1 / derStep;
	endpNzPos = sparseInfo->endpNzPos;

	// ο
	endpInput = (cmscp_endpInput*)malloc(sizeof(cmscp_endpInput));
	for ( iphase = 0; iphase < numPhase; iphase++)
	{
	
		numState = dimension->phase[iphase]->state;
		numParameter = dimension->phase[iphase]->parameter;
		numEndpInput = 2 * numState + numParameter + 2;
		if (dimension->phase[iphase]->endpoint->soc->n)
		{
			numEndpOutput = dimension->phase[iphase]->endpoint->nl + cmscp_sum(dimension->phase[iphase]->endpoint->soc->q, dimension->phase[iphase]->endpoint->soc->n);
		}
		else
		{
			numEndpOutput = dimension->phase[iphase]->endpoint->nl;
		}
		// ϡϢ
		iniStateNzIdxRow = endpNzPos[iphase]->iniState->idxRow;
		iniStateNzPtrCol = endpNzPos[iphase]->iniState->ptrCol;
		finStateNzIdxRow = endpNzPos[iphase]->finState->idxRow;
		finStateNzPtrCol = endpNzPos[iphase]->finState->ptrCol;
		iniTimeNzIdxRow = endpNzPos[iphase]->iniTime->idxRow;
		iniTimeNzPtrCol = endpNzPos[iphase]->iniTime->ptrCol;
		finTimeNzIdxRow = endpNzPos[iphase]->finTime->idxRow;
		finTimeNzPtrCol = endpNzPos[iphase]->finTime->ptrCol;
		parameterNzIdxRow = endpNzPos[iphase]->parameter->idxRow;
		parameterNzPtrCol = endpNzPos[iphase]->parameter->ptrCol;

		// ο
		endpInput->auxdata = setup->auxdata;
		endpInput->initialstate = refTraj[iphase]->state->v;
		endpInput->finalstate = refTraj[iphase]->state->v + refTraj[iphase]->state->m* (refTraj[iphase]->state->n-1);
		endpInput->initialtime = refTraj[iphase]->initialtime;
		endpInput->finaltime = refTraj[iphase]->finaltime;
		endpInput->parameter = refTraj[iphase]->parameter;
		endpFunc = setup->functions->phase[iphase]->endpoint;

		// Ŷռ
		pertEndpInput = (cmscp_endpInput*)malloc(sizeof(cmscp_endpInput));
		pertEndpInput->initialstate = (double*)malloc(numState * sizeof(double));
		pertEndpInput->finalstate = (double*)malloc(numState * sizeof(double));
		pertEndpInput->parameter = (double*)malloc(numParameter * sizeof(double));
		pertEndpInput->auxdata = setup->auxdata;
		
		// οռ
		refOutput = (double*)malloc(numEndpOutput * sizeof(double));
		// Ŷ
		pertOutput = (double*)malloc(numEndpOutput * sizeof(double));

		// ſɱȾ
		endpGrd = (double*)malloc(numEndpOutput * numEndpInput * sizeof(double));

		// ο
		endpFunc(refOutput, endpInput);
		// ʼ״̬
		cntCol = 0;
		for ( j = 0; j < numState; j++)
		{
			copyEndpInput(endpInput, pertEndpInput, iphase, setup);
			pertEndpInput->initialstate[j] = pertEndpInput->initialstate[j] + derStep;
			endpFunc(pertOutput, pertEndpInput);
			for ( p = iniStateNzPtrCol[j]; p < iniStateNzPtrCol[j+1]; p++)
			{
				i = iniStateNzIdxRow[p];
				endpGrd[i + cntCol * numEndpOutput] = (pertOutput[i]- refOutput[i])*derStepInv;
			}
			cntCol++;
		}
		// ն״̬
		for (j = 0; j < numState; j++)
		{
			copyEndpInput(endpInput, pertEndpInput, iphase, setup);
			pertEndpInput->finalstate[j] = pertEndpInput->finalstate[j] + derStep;
			endpFunc(pertOutput, pertEndpInput);
			for (p = finStateNzPtrCol[j]; p < finStateNzPtrCol[j + 1]; p++)
			{
				i = finStateNzIdxRow[p];
				endpGrd[i + cntCol * numEndpOutput] = (pertOutput[i] - refOutput[i]) * derStepInv;
			}
			cntCol++;
		}
		// ʼʱ
		for (j = 0; j < 1; j++)
		{
			copyEndpInput(endpInput, pertEndpInput, iphase, setup);
			pertEndpInput->initialtime = pertEndpInput->initialtime + derStep;
			endpFunc(pertOutput, pertEndpInput);
			for (p = iniTimeNzPtrCol[j]; p < iniTimeNzPtrCol[j + 1]; p++)
			{
				i = iniTimeNzIdxRow[p];
				endpGrd[i + cntCol * numEndpOutput] = (pertOutput[i] - refOutput[i]) * derStepInv;
			}
			cntCol++;
		}
		// նʱ
		for (j = 0; j < 1; j++)
		{
			copyEndpInput(endpInput, pertEndpInput, iphase, setup);
			pertEndpInput->finaltime = pertEndpInput->finaltime + derStep;
			endpFunc(pertOutput, pertEndpInput);
			for (p = finTimeNzPtrCol[j]; p < finTimeNzPtrCol[j + 1]; p++)
			{
				i = finTimeNzIdxRow[p];
				endpGrd[i + cntCol * numEndpOutput] = (pertOutput[i] - refOutput[i]) * derStepInv;
			}
			cntCol++;
		}
		// ̬
		for (j = 0; j < numParameter; j++)
		{
			copyEndpInput(endpInput, pertEndpInput, iphase, setup);
			pertEndpInput->parameter[j] = pertEndpInput->parameter[j] + derStep;
			endpFunc(pertOutput, pertEndpInput);
			for (p = parameterNzPtrCol[j]; p < parameterNzPtrCol[j + 1]; p++)
			{
				i = parameterNzIdxRow[p];
				endpGrd[i + cntCol * numEndpOutput] = (pertOutput[i] - refOutput[i]) * derStepInv;
			}
			cntCol++;
		}
		gradInfo[iphase] = (cmscp_derInfo*)malloc(sizeof(cmscp_derInfo));
		gradInfo[iphase]->ref = refOutput;
		gradInfo[iphase]->der = endpGrd;

		// freeռ
		free(pertEndpInput->initialstate);
		free(pertEndpInput->finalstate);
		free(pertEndpInput->parameter);
		free(pertEndpInput);
		free(pertOutput);
	}
	free(endpInput);
}

void gradInfoSparseCont(cmscp_derInfo** dynGradInfo0, cmscp_derInfo** pathGradInfo0, double* refState, double* refControl, double* refParameter,
	int* stateNzIdxRow, int* controlNzIdxRow, int* parameterNzIdxRow, int* stateNzPtrCol, int* controlNzPtrCol, int* parameterNzPtrCol,
	int numState, int numControl, int numParameter, int numPathOutput, int iphase,  cmscp_setup* setup) {

	int numPhase,  j, p, i,numContInput, cntContInput, idxRowPathGrd;
	double derStep, derStepInv, * refDynOutput, * refPathOutput, *refOutput, * pertOutput, * dynGrd, * pathGrd, * pertDynOutput, * pertPathOutput;
	cmscp_dimension* dimension;
	cmscp_mesh** mesh;
	cmscp_contInput* contInput, * pertContInput;
	cmscp_continuous contFunc;

	//  1. 
	dimension = setup->dimension;	// άϢ
	mesh = setup->mesh;	// Ϣ
	numPhase = setup->numPhase;	// ׶
	derStep = setup->derStep; // 󵼲
	derStepInv = 1 / derStep;

	// 躯Ա[x, u, p]
	// ĲοŶ
	contInput = (cmscp_contInput*)malloc(sizeof(cmscp_contInput));// ο
	contInput->auxdata = setup->auxdata; 
	contInput->state = refState;
	contInput->control = refControl;
	contInput->parameter = refParameter;
	pertContInput = (cmscp_contInput*)malloc(sizeof(cmscp_contInput));
	pertContInput->auxdata = setup->auxdata; // Ŷ
	pertContInput->state = (double*)malloc(numState * sizeof(double));
	pertContInput->control = (double*)malloc(numControl * sizeof(double));
	pertContInput->parameter = (double*)malloc(numParameter * sizeof(double));

	// 
	contFunc = setup->functions->phase[iphase]->continuous;
	
	// ĲοŶ
	refDynOutput = dynGradInfo0[0]->ref; // (double*)malloc(numState * sizeof(double));
	refPathOutput = pathGradInfo0[0]->ref; // (double*)malloc(numPathOutput * sizeof(double));
	contFunc(refDynOutput, refPathOutput, contInput); // οֵ
	pertDynOutput = (double*)malloc(numState * sizeof(double));
	pertPathOutput =  (double*)malloc(numPathOutput * sizeof(double));

	// ſɱȾ
	numContInput = numState + numControl + numParameter;
	dynGrd = dynGradInfo0[0]->der;// (double*)malloc(numState * numContInput * sizeof(double));
	pathGrd = pathGradInfo0[0]->der; //  (double*)malloc(numPathOutput * numContInput * sizeof(double));
	cntContInput = 0;
	for ( j = 0; j < numState; j++)
	{
		copyContInput(contInput, pertContInput, numState, numControl, numParameter, setup);
		pertContInput->state[j] = pertContInput->state[j] + derStep;
		contFunc(pertDynOutput, pertPathOutput, pertContInput);
		for ( p = stateNzPtrCol[j]; p < stateNzPtrCol[j+1]; p++)
		{
			i = stateNzIdxRow[p]; // 
			if (i < numState)
			{
				dynGrd[i+cntContInput*numState] = (pertDynOutput[i] - refDynOutput[i]) * derStepInv;
			}
			else
			{
				idxRowPathGrd = i - numState;
				pathGrd[idxRowPathGrd + numPathOutput * cntContInput] = (pertPathOutput[idxRowPathGrd] - refPathOutput[idxRowPathGrd]) * derStepInv;;
			}
		}
		cntContInput++;
	}
	// Ʊ
	for (j = 0; j < numControl; j++)
	{
		copyContInput(contInput, pertContInput, numState, numControl, numParameter, setup);
		pertContInput->control[j] = pertContInput->control[j] + derStep;
		contFunc(pertDynOutput, pertPathOutput, pertContInput);
		for (p = controlNzPtrCol[j]; p < controlNzPtrCol[j + 1]; p++)
		{
			i = controlNzIdxRow[p]; // 
			if (i < numState)
			{
				dynGrd[i+cntContInput * numState] = (pertDynOutput[i] - refDynOutput[i]) * derStepInv;
			}
			else
			{
				idxRowPathGrd = i - numState;
				pathGrd[idxRowPathGrd + numPathOutput * cntContInput] = (pertPathOutput[idxRowPathGrd] - refPathOutput[idxRowPathGrd]) * derStepInv;;
			}
		}
		cntContInput++;
	}
	// ̬
	for (j = 0; j < numParameter; j++)
	{
		copyContInput(contInput, pertContInput, numState, numControl, numParameter, setup);
		pertContInput->parameter[j] = pertContInput->parameter[j] + derStep;
		contFunc(pertDynOutput, pertPathOutput, pertContInput);
		for (p = parameterNzPtrCol[j]; p < parameterNzPtrCol[j + 1]; p++)
		{
			i = parameterNzIdxRow[p]; // 
			if (i < numState)
			{
				dynGrd[i+cntContInput * numState] = (pertDynOutput[i] - refDynOutput[i]) * derStepInv;
			}
			else
			{
				idxRowPathGrd = i - numState;
				pathGrd[idxRowPathGrd + numPathOutput * cntContInput] = (pertPathOutput[idxRowPathGrd] - refPathOutput[idxRowPathGrd]) * derStepInv;;
			}
		}
		cntContInput++;
	}
	free(pertDynOutput);
	free(pertPathOutput);
	free(pertContInput->state);
	free(pertContInput->control);
	free(pertContInput->parameter);
	free(pertContInput);
	free(contInput);
	
}
void gradInfoSparseLink(cmscp_derInfo** gradInfo, cmscp_sparseInfo* sparseInfo, cmscp_trajInfo** refTraj, cmscp_setup* setup) {
	// 
	int numPhase, numObjEventInput, numEventOutput, iphase, numState, numControl, numParameter, numMesh, cntObjEventInput, * iniStateNzIdxRow, * finStateNzIdxRow, * iniTimeNzIdxRow, * finTimeNzIdxRow, * parameterNzIdxRow, * iniStateNzPtrCol, * finStateNzPtrCol, * iniTimeNzPtrCol, * finTimeNzPtrCol, * parameterNzPtrCol, j, p, i, idxRowEventGrd, numLinkInput, numLinkOutput, cntCol, * leftStatefIdxRow, * leftStatefPtrCol, * leftTfIdxRow, * leftTfPtrCol, * leftParameterIdxRow, * leftParameterPtrCol, * rightState0IdxRow, * rightState0PtrCol, * rightT0IdxRow, * rightT0PtrCol, * rightParameterIdxRow, * rightParameterPtrCol, numStateK, numStateKp1, numParameterK, numParameterKp1;;
	double derStep, derStepInv, * refOutput, * pertOutput, * linkGrd;
	cmscp_dimension* dimension;
	cmscp_mesh** mesh;
	cmscp_nzPos_link** linkNzPos;
	cmscp_linkInput* linkInput, * pertLinkInput;
	cmscp_linkage linkFunc;


	//  1. 
	dimension = setup->dimension;	// άϢ
	mesh = setup->mesh;	// Ϣ
	numPhase = setup->numPhase;	// ׶
	derStep = setup->derStep; // 󵼲
	derStepInv = 1 / derStep;
	linkNzPos = sparseInfo->linkNzPos;

	// ο
	linkInput = (cmscp_linkInput*)malloc(sizeof(cmscp_linkInput));
	pertLinkInput = (cmscp_linkInput*)malloc(sizeof(cmscp_linkInput));
	for (iphase = 0; iphase < numPhase-1; iphase++)
	{
		numStateK = dimension->phase[iphase]->state;
		numStateKp1 = dimension->phase[iphase + 1]->state;
		numParameterK = dimension->phase[iphase]->parameter;
		numParameterKp1 = dimension->phase[iphase + 1]->parameter;
		numLinkInput = numStateK + numStateKp1 + numParameterK + numParameterKp1 + 2;
		if (dimension->phase[iphase]->linkage->soc->n)
		{
			numLinkOutput = dimension->phase[iphase]->linkage->nl + cmscp_sum(dimension->phase[iphase]->linkage->soc->q, dimension->phase[iphase]->linkage->soc->n);
		}
		else
		{
			numLinkOutput = dimension->phase[iphase]->linkage->nl;
		}
		// ϡϢ
		leftStatefIdxRow = linkNzPos[iphase]->leftStatef->idxRow;
		leftStatefPtrCol = linkNzPos[iphase]->leftStatef->ptrCol;
		leftTfIdxRow = linkNzPos[iphase]->leftTf->idxRow;
		leftTfPtrCol = linkNzPos[iphase]->leftTf->ptrCol;
		leftParameterIdxRow = linkNzPos[iphase]->leftParameter->idxRow;
		leftParameterPtrCol = linkNzPos[iphase]->leftParameter->ptrCol;
		rightState0IdxRow = linkNzPos[iphase]->rightState0->idxRow;
		rightState0PtrCol = linkNzPos[iphase]->rightState0->ptrCol;
		rightT0IdxRow = linkNzPos[iphase]->rightT0->idxRow;
		rightT0PtrCol = linkNzPos[iphase]->rightT0->ptrCol;
		rightParameterIdxRow = linkNzPos[iphase]->rightParameter->idxRow;
		rightParameterPtrCol = linkNzPos[iphase]->rightParameter->ptrCol;
		// ο
		linkInput->auxdata = setup->auxdata;
		linkInput->leftFinState = refTraj[iphase]->state->v + refTraj[iphase]->state->m * (refTraj[iphase]->state->n - 1);
		linkInput->leftFinTime = refTraj[iphase]->finaltime;
		linkInput->leftParameter = refTraj[iphase]->parameter;
		linkInput->rightIniState = refTraj[iphase + 1]->state->v;
		linkInput->rightIniTime = refTraj[iphase + 1]->initialtime;
		linkInput->rightParameter = refTraj[iphase + 1]->parameter;
		// νӵ㺯
		linkFunc = setup->functions->phase[iphase]->linkage;

		// Ŷռ
		pertLinkInput->auxdata = setup->auxdata;
		pertLinkInput->leftFinState = (double*)malloc(dimension->phase[iphase]->state * sizeof(double));
		pertLinkInput->leftParameter = (double*)malloc(dimension->phase[iphase]->parameter * sizeof(double));
		pertLinkInput->rightIniState = (double*)malloc(dimension->phase[iphase+1]->state * sizeof(double));
		pertLinkInput->rightParameter = (double*)malloc(dimension->phase[iphase + 1]->parameter * sizeof(double));

		// οռ
		refOutput = (double*)malloc(numLinkOutput * sizeof(double));

		// Ŷ
		pertOutput = (double*)malloc(numLinkOutput * sizeof(double));

		// ſɱȾ
		linkGrd = (double*)malloc(numLinkOutput * numLinkInput * sizeof(double));

		// ο
		linkFunc(refOutput, linkInput);

		// ն״̬
		cntCol = 0;
		for (j = 0; j < numStateK; j++)
		{
			copyLinkInput(linkInput, pertLinkInput, iphase, setup);
			pertLinkInput->leftFinState[j] = pertLinkInput->leftFinState[j] + derStep;
			linkFunc(pertOutput, pertLinkInput);
			for (p = leftStatefPtrCol[j]; p < leftStatefPtrCol[j + 1]; p++)
			{
				i = leftStatefIdxRow[p];
				linkGrd[i + cntCol * numLinkOutput] = (pertOutput[i] - refOutput[i]) * derStepInv;
			}
			cntCol++;
		}
		// նʱ
		copyLinkInput(linkInput, pertLinkInput, iphase, setup); // Ŷ
		pertLinkInput->leftFinTime = pertLinkInput->leftFinTime + derStep;
		linkFunc(pertOutput, pertLinkInput);
		for ( p = leftTfPtrCol[0]; p < leftTfPtrCol[1]; p++)
		{
			i = leftTfIdxRow[p]; // 
			linkGrd[i + cntCol * numLinkOutput] = (pertOutput[i] - refOutput[i]) * derStepInv;
		}
		cntCol = cntCol + 1;
		// ྲ̬
		for ( j = 0; j < numParameterK; j++)
		{
			copyLinkInput(linkInput, pertLinkInput, iphase, setup); // Ŷ
			pertLinkInput->leftParameter[j] = pertLinkInput->leftParameter[j] + derStep;
			linkFunc(pertOutput, pertLinkInput);
			for ( p = leftParameterPtrCol[j]; p < leftParameterPtrCol[j + 1]; p++)
			{
				i = leftParameterIdxRow[p]; // 
				linkGrd[i + cntCol * numLinkOutput] = (pertOutput[i] - refOutput[i]) * derStepInv;
			}
			cntCol = cntCol + 1;
		}

		// Ҳʼ״̬
		for (j = 0; j < numStateKp1; j++)
		{
			copyLinkInput(linkInput, pertLinkInput, iphase, setup); // Ŷ
			pertLinkInput->rightIniState[j] = pertLinkInput->rightIniState[j] + derStep;
			linkFunc(pertOutput, pertLinkInput);
			for (p = rightState0PtrCol[j]; p < rightState0PtrCol[j + 1]; p++)
			{
				i = rightState0IdxRow[p]; // 
				linkGrd[i + cntCol * numLinkOutput] = (pertOutput[i] - refOutput[i]) * derStepInv;
			}
			cntCol = cntCol + 1;
		}
		// Ҳնʱ
		copyLinkInput(linkInput, pertLinkInput, iphase, setup); // Ŷ
		pertLinkInput->rightIniTime = pertLinkInput->rightIniTime + derStep;
		linkFunc(pertOutput, pertLinkInput);
		for (p = rightT0PtrCol[0]; p < rightT0PtrCol[1]; p++)
		{
			i = rightT0IdxRow[p]; // 
			linkGrd[i + cntCol * numLinkOutput] = (pertOutput[i] - refOutput[i]) * derStepInv;
		}
		cntCol = cntCol + 1;
		// Ҳྲ̬
		for ( j = 0; j < numParameterKp1; j++)
		{
			copyLinkInput(linkInput, pertLinkInput, iphase, setup); // Ŷ
			pertLinkInput->rightParameter[j] = pertLinkInput->rightParameter[j] + derStep;
			linkFunc(pertOutput, pertLinkInput);
			for ( p = rightParameterPtrCol[j]; p < rightParameterPtrCol[j+1]; p++)
			{
				i = rightParameterIdxRow[p]; // 
				linkGrd[i + cntCol * numLinkOutput] = (pertOutput[i] - refOutput[i]) * derStepInv;
			}
			cntCol = cntCol + 1;
		}
		gradInfo[iphase] = (cmscp_derInfo*)malloc(sizeof(cmscp_derInfo));
		gradInfo[iphase]->ref = refOutput;
		gradInfo[iphase]->der = linkGrd;
		// freeռ
		free(pertLinkInput->leftFinState);
		free(pertLinkInput->leftParameter);
		free(pertLinkInput->rightIniState);
		free(pertLinkInput->rightParameter);
		free(pertOutput);
	}
	free(pertLinkInput);
	free(linkInput);
}