#include "numericalFunctions.h"

// Լ
void linSpace(double x1, double x2, int n, double* y) {
	int i;
	double d;
	d = (x2 - x1) / (n - 1);
	y[0] = x1;
	y[n - 1] = x2;
	for (i = 1; i < n - 1; i++)
	{
		y[i] = y[i - 1] + d;
	}
}

void ascLinearInterp(double* X, double* Y, int N, int M, double* x, int n, double* y) {
	// Բֵ
	//  :
	// Ϊֵڵ, ά 1 * N
	// Ϊֵڵ㴦ĺֵά M * N
	// N ΪֵڵĿ
	// M Ϊֵά
	// :
	// x Ϊ, ά 1 * n
	// n Ϊά
	// y Ϊάά M * n
	// Ҫ
	// X ΪX(1) <= X(2) <= ...X(i) <= ... <= X(N)
	// x Ϊx(1) <= x(2) <= ...x(i) <= ... <= x(n)

	int i, j, k, js, yidxs, Yidxs, Y1idxs;
	js = 0;
	yidxs = 0;
	for (i = 0; i < n; i++) {
		if (x[i] <= X[0]) {
			for (k = 0; k < M; k++) {
				y[yidxs + k] = Y[k];
			}
		}
		else if (x[i] > X[N - 1]) {
			Yidxs = (N - 1) * M;
			for (k = 0; k < M; k++) {
				y[yidxs + k] = Y[Yidxs + k];
			}
		}
		else {
			for (j = js; j < N - 1; j++) {
				if (x[i] > X[j] && x[i] <= X[j + 1]) {
					Yidxs = j * M;
					Y1idxs = (j + 1) * M;
					for (k = 0; k < M; k++) {
						y[yidxs + k] = Y[Yidxs + k] + (Y[Y1idxs + k] - Y[Yidxs + k]) / (X[j + 1] - X[j]) * (x[i] - X[j]);
					}
					js = j;
					break;
				}
			}
		}
		yidxs += M;
	}

}

void computeInteg(double* newState, // ״̬
	dynIntegFunc pfun, // ѧ
	double* oldState, double* control, double* parameter, void* auxdata, // ѧ
	int numState, int numControl, int numParameter, int numPath, // ά
	double* tempWork, // ʱռ䣬ظͷſռ
	double stepSize, int integMode) // ֲͻģʽ
{
	int i;
	double* path, * dynRhs1, * dynRhs2, * dynRhs3, * dynRhs4, temp;
	/* ֹм·Һֵ */
	path = tempWork;
	dynRhs1 = path + numPath;
	dynRhs2 = dynRhs1 + numState;
	dynRhs3 = dynRhs2 + numState;
	dynRhs4 = dynRhs3 + numState;
	/* ֵֹʽ */
	switch (integMode) {
	case 1: // ŷ
		pfun(dynRhs1, NULL, oldState, control, parameter, auxdata);
		for (i = 0; i < numState; i++) {
			newState[i] = oldState[i] + stepSize * dynRhs1[i];
		};
		break;
	case 2: // Ľŷ
		temp = 0.5 * stepSize;
		pfun(dynRhs1, NULL, oldState, control, parameter, auxdata);
		for (i = 0; i < numState; i++) {
			newState[i] = oldState[i] + stepSize * dynRhs1[i];
		};
		pfun(dynRhs2, NULL, newState, control, parameter, auxdata);
		for (i = 0; i < numState; i++) {
			newState[i] = oldState[i] + temp * (dynRhs1[i] + dynRhs2[i]);
		};
		break;
	case 3: // Ľ
		temp = 0.5 * stepSize;
		pfun(dynRhs1, NULL, oldState, control, parameter, auxdata);
		for (i = 0; i < numState; i++) {
			newState[i] = oldState[i] + temp * dynRhs1[i];
		};
		pfun(dynRhs2, NULL, newState, control, parameter, auxdata);
		for (i = 0; i < numState; i++) {
			newState[i] = oldState[i] + temp * dynRhs2[i];
		};
		pfun(dynRhs3, NULL, newState, control, parameter, auxdata);
		for (i = 0; i < numState; i++) {
			newState[i] = oldState[i] + stepSize * dynRhs3[i];
		};
		temp = stepSize / 6;
		pfun(dynRhs4, NULL, newState, control, parameter, auxdata);
		for (i = 0; i < numState; i++) {
			newState[i] = oldState[i] + temp * (dynRhs1[i] + 2 * dynRhs2[i] + 2 * dynRhs3[i] + dynRhs4[i]);
		};
		break;
	default:
		break;
	}
}

void copyIntVec(int* x, int* y, int n, int isNegtive) {
	// ܣnάxƸy
	// 룺
	// xԭ
	// n
	// isNegtiveǷȡŸ
	// 
	// yƺ
	// лڣ2022 / 6 / 25д
	int i;
	if (isNegtive == 0) {
		for (i = 0; i < n; i++)
		{
			y[i] = x[i];
		}
	}
	else
	{
		for (i = 0; i < n; i++)
		{
			y[i] = -x[i];
		}
	}
}
void copyFloatVec(double* x, double* y, int n, int isNegtive) {
	int i;
	if (isNegtive == 0) {
		for (i = 0; i < n; i++)
		{
			y[i] = x[i];
		}
	}
	else
	{
		for (i = 0; i < n; i++)
		{
			y[i] = -x[i];
		}
	}
}

void floatVecFillin(double* x, int n, double a) {
	int i;
	for ( i = 0; i < n; i++)
	{
		x[i] = a;
	}
}
void intVecFillin(int* x, int n, int a) {
	// ܣnάȫֵΪa
	// 룺
	// x׵ַ
	// n
	// aҪֵֵ
	// 
	// xֵ
	// лڣ2022 / 6 / 25д
	int i;
	for (i = 0; i < n; i++)
	{
		x[i] = a;
	}
}