/**
 * @file csocp_attr.h
 * @brief 实现属性(attribute)模块. 
 * This file implements attribute module. 
 */

#ifndef __CSOCP_ATTR_H__
#define __CSOCP_ATTR_H__

#include "csocp_config.h"

/** 重置所有属性为默认值 Reset attributes to default values. */
void c_attr_reset(c_attr *attr /**< 输入：属性结构体 Input attribute structure */
);

/** 复制属性 Copy attributes  */
void c_attr_copy(c_attr *src_attr, /**< 输入：属性结构体 Input attribute structure */
                 c_attr *dst_attr  /**< 输出：属性结构体 Output attribute structure */
);

/** 获取double类型属性 Get double attribute */
c_real c_attr_getdbl(c_attr *attr, /**< 输入：属性结构体 Input attribute structure */
                     c_int dblattr /**< 输入：double类型属性ID ID of double attribute */
);

/** 获取integer类型属性 Get integer attribute */
c_int c_attr_getint(c_attr *attr, /**< 输入：属性结构体 Input attribute structure */
                    c_int intattr /**< 输入：integer类型属性ID ID of integer attribute */
);

/** 获取属性结构体的大小 Get memory requirement of attribute */
c_int c_attr_getmem();

#endif
