/**
 * @file csocp_config.h
 * @brief 实现默认配置文件
 * Default configuration for CSOCP solver
 * @version 0.1
 * @date 2021-09-17
 * 
 * @copyright Copyright (c) 2021
 * 
 */
#ifndef __CSOCP_CONFIG_H__
#define __CSOCP_CONFIG_H__

#define CSOCP_WITH_TIMER 1 /**< 注释当前行以禁用时间器 Comment current line to disable timer */

#define CSOCP_WITH_PRINT 1 /**< 注释当前行以禁用日志打印 Comment current line to disable log display */

#define CSOCP_WITH_INTERRUPT 1 /**< 注释当前行以禁用中断 Comment current line to disable this module */

#define CSOCP_WITH_DEBUG 1 /**< 注释当前行以禁用调试功能 Comment current line to disable debug tools */

#define MATLAB_FLUSH_PRINTS 1 /**< 在 MATLAB 中更新日志显示 Flush log display in MATLAB */

#define CSOCP_INFINITY +1e100 /**< 无穷常数 Infinity constant */

// #define CSOCP_TI_INSTRUCTIONS 1 /**< 注释当前行以禁用 TI DSP 指令集 */

typedef double c_real; /**< double类型重定义 Type redefinition for double */
typedef int c_int; /**< int类型重定义 Type redefinition for int */

/* Forward declaration */
typedef struct c_attr_s c_attr;
typedef struct c_param_s c_param;

typedef struct c_spmat_s c_spmat;

typedef struct c_lp_s c_lp;
typedef struct c_soc_s c_soc;
typedef struct c_cone_s c_cone;

typedef struct c_kkt_s c_kkt;

typedef struct c_prob_s csocp_prob;

#endif
