/**
 * @file csocp_param.h
 * @brief 定义参数(parameter)模块
 * This is definition of parameter module
 * @version 0.1
 * @date 2021-09-17
 * 
 * @copyright Copyright (c) 2021
 * 
 */

#ifndef __CSOCP_PARAM_H__
#define __CSOCP_PARAM_H__

#include "csocp_config.h"

/** 重置参数至默认值 Reset parameters to default values */
void c_param_reset(c_param *param /**< 输入：参数 Input parameter */
);

/** 设置double类型参数 Set double parameter */
void c_param_setdbl(c_param *param, /**< 输入：参数 Input parameter */
                    c_int dblparam, /**< double类型参数的ID ID of double parameter */
                    c_real newval   /**< 输入：新参数值 New value */
);

/** 设置integer类型参数 Set integer parameter */
void c_param_setint(c_param *param, /**< 输入：参数 Input parameter */
                    c_int intparam, /**< integer类型参数的ID ID of integer parameter */
                    c_int newval    /**< 输入：新参数值 New value */
);

/** 获取double类型参数 Get double parameter */
c_real c_param_getdbl(c_param *param, /**< 输入：参数 Input parameter */
                      c_int dblparam  /**< double类型参数的ID ID of double parameter */
);

/** 获取integer类型参数 Get integer parameter */
c_int c_param_getint(c_param *param, /**< 输入：参数 Input parameter */
                     c_int intparam  /**< integer类型参数的ID ID of integer parameter */
);

/** 获取参数的内存需求量 Get memory requirement of parameter */
c_int c_param_getmem();

#endif
