/**
 * @file csocp_scaling.h
 * @brief 实现缩放功能相关的函数。本模块是预处理模块的一部分。
 * This file implements routines for scaling methods. This module serves as part of presolving module
 * @version 0.1
 * @date 2021-09-17
 * 
 * @copyright Copyright (c) 2021
 * 
 */

#ifndef __CSOCP_SCALING_H__
#define __CSOCP_SCALING_H__

#include "csocp_config.h"

/** 缩放优化问题 Scale the problem */
void c_scaling_set(csocp_prob *prob);

/** 获取缩放优化问题的内存需求量 Get memory requirement of scaling */
c_int c_scaling_getmem(c_int n, /**< 变量数量 Number of variables */
                       c_int m, /**< 不等式约束数量 Number of inequalities */
                       c_int p  /**< 等式约束数量 Number of equalities */
);

#endif
