/**
 * @file struct_kkt.h
 * @brief 定义KKT结构体
 * This is definition of KKT structure
 * @version 0.1
 * @date 2021-09-17
 * 
 * @copyright Copyright (c) 2021
 * 
 */

#ifndef __STRUCT_KKT_H__
#define __STRUCT_KKT_H__

#include "csocp_config.h"

/** KKT结构体定义 Definition of KKT structure */
struct c_kkt_s {
  c_spmat *kmat; /**< KKT矩阵 KKT matrix */
  c_spmat *L;    /**< LDL分解后的L矩阵 Factor L by LDL */
  c_real *D;     /**< LDL分解后的D矩阵 Diagonal matrix D by LDL */

  c_int nordermem; /**< ordering方法的内存需求量 Memory of ordering method */
  c_int *idxmap;   /**< Index map */
  c_int *invmap;   /**< Reverse index map */
  c_int *etree;    /**< 消去树 Elimination tree */
  c_int *sign;     /**< Sign vector */
  c_int *pattern;
  c_int *flag;
  c_int *lnz;

  c_real *rhs1;
  c_real *rhs2;

  c_real *work1;
  c_real *work2;
  c_real *work3;
  c_real *work4;
  c_real *work5;
  c_real *work6;
};

#endif
