/**
 * @file tool_interrupt.h
 * @brief 实现中断模块
 * This file implements interrupt handling.
 * 
 * @version 0.1
 * @date 2021-09-17
 * 
 * @copyright Copyright (c) 2021
 * 
 * This module serves as utility module, don't waste time in reading it.
 * 
 * To enable this module, just define macro 'CSOCP_WITH_INTERRUPT' when compiling it;
 * othewise, it is disabled.
 *  
 * \note Notice that this module is needed only during development, and should be disabled
 * when used in production.
 */

#ifndef __TOOL_INTERRUPT_H__
#define __TOOL_INTERRUPT_H__

/** 创建中断函数句柄 Create interrupt handler */
void c_interrupt_register(void);

/** 删除中断函数句柄 Remove interrupt handler */
void c_interrupt_reset(void);

/** 检查中断操作 Check for interrupt action */
int c_interrupt_check(void);

#endif
