/**
 * This file implements attribute module for the CSOCP solver
 */

#ifndef __CSOCP_ATTR_H__
#define __CSOCP_ATTR_H__

#include "csocp_config.h"

/* Reset attributes to default values */
void c_attr_reset(c_attr *attr /* Input attribute structure */
);

/* Copy attributes */
void c_attr_copy(c_attr *src_attr, /* Input attribute structure */
                 c_attr *dst_attr  /* Output attribute structure */
);

/* Get double attribute */
c_real c_attr_getdbl(c_attr *attr, /* Input attribute structure */
                     c_int dblattr /* ID of double attribute */
);

/* Get integer attribute */
c_int c_attr_getint(c_attr *attr, /* Input structure structure */
                    c_int intattr /* ID of integer attribute */
);

/* Get memory requirement of attribute */
c_int c_attr_getmem();

#endif
