/**
 * This is definition of parameter module for the CSOCP solver
 */

#ifndef __CSOCP_PARAM_H__
#define __CSOCP_PARAM_H__

#include "csocp_config.h"

/* Reset parameters to default values */
void c_param_reset(c_param *param /* Input parameter */
);

/* Set double parameter */
void c_param_setdbl(c_param *param, /* Input parameter */
                    c_int dblparam, /* ID of double parameter */
                    c_real newval   /* New value */
);

/* Set integer parameter */
void c_param_setint(c_param *param, /* Input parameter */
                    c_int intparam, /* ID of integer parameter */
                    c_int newval    /* New value */
);

/* Get double parameter */
c_real c_param_getdbl(c_param *param, /* Input parameter */
                      c_int dblparam  /* ID of double parameter */
);

/* Get integer parameter */
c_int c_param_getint(c_param *param, /* Input parameter */
                     c_int intparam  /* ID of integer parameter */
);

/* Get memory requirement of parameter */
c_int c_param_getmem();

#endif
