/**
 * This file implements solver module of the CSOCP solver
 */

#ifndef __CSOCP_SOLVER_H__
#define __CSOCP_SOLVER_H__

#include "csocp_config.h"

/* Compute the starting point */
c_int c_solver_startpoint(csocp_prob *prob /* The CSOCP problem */
);

/* Predicator step */
void c_solver_predictor(csocp_prob *prob, /* The CSOCP problem */
                        c_real *p_res     /* Output residual */
);

/* Centering step */
void c_solver_centering(csocp_prob *prob /* The CSOCP problem */
);

/* Corrector step */
void c_solver_corrector(csocp_prob *prob, /* The CSOCP problem */
                        c_real res        /* Input residual */
);

/* Get memory requirement of CSOCP solver */
c_int c_solver_getmem(c_int n,    /* Number of variables */
                      c_int m,    /* Number of inequalities */
                      c_int p,    /* Number of equalities */
                      c_int nnzA, /* Number of nonzeros of A */
                      c_int nnzG  /* Number of nonzeros of G */
);

#endif
