/**
 * This is definition of KKT structure for the CSOCP solver
 */

#ifndef __STRUCT_KKT_H__
#define __STRUCT_KKT_H__

#include "csocp_config.h"
#ifdef CSOCP_WITH_DEBUG
#include <stdio.h>
#endif

/* Definition of KKT structure */
struct c_kkt_s {
#ifdef CSOCP_WITH_DEBUG
  FILE *dbgfile; /* Debug log file */
#endif

  c_spmat *kmat; /* Permuated KKT matrix */
  c_spmat *L;    /* Factor L by LDL */
  c_real *D;     /* Diagonal matrix D by LDL */
  c_int *idxmap; /* Map for nonzeros index after ordering */
  c_int *invmap; /* Map for column index after ordering */
  c_int *etree;  /* Elimination tree */
  c_int *sign;   /* Sign vector */
  c_real *rhs1;  /* RHS1 */
  c_real *rhs2;  /* RHS2 */
};

#endif
