/**
 * This is the definition of sparse matrix structure in CSOCP solver
 *
 * We split function prototypes and struct definition into two files for better
 * code engineering.
 */

#ifndef __STRUCT_SPMAT_H__
#define __STRUCT_SPMAT_H__

#include "csocp_config.h"

/* Data structure for sparse matrices */
struct c_spmat_s {
  c_int nCol;      /* Number of columns */
  c_int nRow;      /* Number of rows */
  c_int nElem;     /* Number of nonzeros */
  c_int *colBeg;   /* Begin pointer of column-wise matrix */
  c_int *colIdx;   /* Index pointer of column-wise matrix */
  c_real *colElem; /* Element pointer of column-wise matrix */
};

#endif
