/**
 * This is function prototypes for buffer in CSOCP solver
 */

#ifndef __TOOL_BUFFER_H__
#define __TOOL_BUFFER_H__

#include "csocp_config.h"

#include "tool_print.h"

#include "struct_buffer.h"

/* Create buffer */
void c_buffer_create(c_buffer **p_buffer, /* Pointer to buffer */
                     c_int isize,         /* Size of integer buffer */
                     c_int dsize          /* Size of double buffer */
);

/* Free buffer */
void c_buffer_free(c_buffer **p_buffer /* Pointer to buffer */
);

/* Get memory usage of buffer */
c_int c_buffer_getmem(c_int isize, /* Size of integer buffer */
                      c_int dsize  /* Size of double buffer */
);

/*
 * Macros for buffer operation
 */
#define c_buffer_request_ibuf(buffer, x, size)                                         \
  (x) = (buffer)->ibuf + (buffer)->ibeg;                                               \
  (buffer)->ibeg += (size)
#define c_buffer_release_ibuf(buffer, size) (buffer)->ibeg -= (size)

#define c_buffer_request_dbuf(buffer, x, size)                                         \
  (x) = (buffer)->dbuf + (buffer)->dbeg;                                               \
  (buffer)->dbeg += (size)
#define c_buffer_release_dbuf(buffer, size) (buffer)->dbeg -= (size)

#endif
